'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created by ex90rts on 12/05/2017.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var disableBackground = '#f6f7f8';
var defaultBackground = '#fff';

var ButtonGroup = function (_React$Component) {
  _inherits(ButtonGroup, _React$Component);

  function ButtonGroup() {
    _classCallCheck(this, ButtonGroup);

    return _possibleConstructorReturn(this, (ButtonGroup.__proto__ || Object.getPrototypeOf(ButtonGroup)).apply(this, arguments));
  }

  _createClass(ButtonGroup, [{
    key: 'getBackground',
    value: function getBackground() {
      var _props = this.props,
          children = _props.children,
          fixedBottom = _props.fixedBottom,
          background = _props.background;

      var bg = background;
      var hasBanner = false;
      var hasDisabled = false;
      var child = [];
      if (!children.length || !children.splice) {
        child.push(children);
      } else {
        child = [].concat(_toConsumableArray(children));
      }
      child.forEach(function (item) {
        var _item$props = item.props,
            type = _item$props.type,
            disabled = _item$props.disabled,
            display = _item$props.display;

        if (type !== 'primary') {
          // 非主按钮存在disable状态
          if (disabled) {
            hasDisabled = true;
          }
        } else {
          // 主按钮存在disable状态
          if (disabled) {
            // 如果只有一个主按钮，那就设置成disable的颜色，否则设置成其它普通按钮的颜色
            bg = child.length === 1 ? disableBackground : defaultBackground;
          }
        }
        if (display === 'banner') {
          hasBanner = true;
        }
      });
      // 非主按钮存在disable状态时，一律返回disable颜色
      if (hasDisabled) {
        bg = disableBackground;
      }
      return hasBanner || fixedBottom ? bg : 'transparent';
    }
  }, {
    key: 'render',
    value: function render() {
      var _classes;

      var fixedBottom = this.props.fixedBottom;

      var classes = (_classes = {}, _defineProperty(_classes, '' + (0, _utils.prefixClass)('button-group'), true), _defineProperty(_classes, 'fixed-bottom', fixedBottom), _classes);
      return _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)(classes), style: { background: this.getBackground() } },
        this.props.children
      );
    }
  }]);

  return ButtonGroup;
}(_react2.default.Component);

ButtonGroup.defaultProps = {
  children: [],
  fixedBottom: false,
  background: defaultBackground
};

ButtonGroup.propTypes = {
  children: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.array]),
  fixedBottom: _propTypes2.default.bool,
  background: _propTypes2.default.string
};

exports.default = ButtonGroup;
module.exports = exports['default'];