'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _cloneDeep = require('lodash/cloneDeep');

var _cloneDeep2 = _interopRequireDefault(_cloneDeep);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _Toast = require('../../Toast');

var _Toast2 = _interopRequireDefault(_Toast);

var _Context = require('../../Context');

var _Button = require('../../Button');

var _Button2 = _interopRequireDefault(_Button);

var _Panel2 = require('./Panel');

var _Panel3 = _interopRequireDefault(_Panel2);

var _const = require('./const');

var _util = require('../util');

var _util2 = _interopRequireDefault(_util);

var _locale = require('../locale');

var _locale2 = _interopRequireDefault(_locale);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Calendar Component for SaltUI
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author quanyun.mqy
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * 继承自Panel，只处理级联相关的逻辑
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2018-2019, SaltUI Team.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var CascadePanel = function (_Panel) {
  _inherits(CascadePanel, _Panel);

  _createClass(CascadePanel, null, [{
    key: 'processValue',
    value: function processValue(propValue) {
      var value = (0, _cloneDeep2.default)(propValue);
      if (_util2.default.isNil(value)) {
        value = {};
      } else if (/^\d*$/.test(value)) {
        value = {
          startDate: new Date(parseInt(value, 10)).getTime()
        };
      } else if (typeof value === 'string') {
        value = {
          startDate: new Date(value).getTime()
        };
      }
      if (Object.prototype.toString.call(propValue) === '[object Object]') {
        var result = (0, _util.adaptCascadeDate)(propValue.startDate, propValue.endDate);
        value = {
          startDate: result.startDate,
          endDate: result.endDate
        };
      } else if (Object.prototype.toString.call(propValue) === '[object Array]') {
        var _result = (0, _util.adaptCascadeDate)(propValue[0], propValue[1] || propValue[0]);
        value = {
          startDate: _result.startDate,
          endDate: _result.endDate
        };
      }
      var newValue = _extends({}, propValue, value);

      var activeDate = void 0;
      var activeType = '';

      if (!_util2.default.isNil(newValue.startDate)) {
        activeDate = newValue.startDate;
        activeType = 'start';
      }
      if (!_util2.default.isNil(newValue.endDate)) {
        activeDate = newValue.endDate;
        activeType = 'end';
      }

      return {
        value: newValue,
        activeDate: activeDate,
        activeType: activeType
      };
    }
  }]);

  function CascadePanel(props) {
    _classCallCheck(this, CascadePanel);

    var _this = _possibleConstructorReturn(this, (CascadePanel.__proto__ || Object.getPrototypeOf(CascadePanel)).call(this, props));

    _this.isASC = true; // 是否是正序选择。第二次点击的日期，晚于第一次点击的日期，则为正序选择
    _this.state = _extends({}, _this.state, CascadePanel.processValue(props.value));
    return _this;
  }

  _createClass(CascadePanel, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      var value = this.state.value;

      if (!value.startDate) {
        this.showToast(true);
      } else if (!value.endDate) {
        this.showToast(false);
      }
    }
  }, {
    key: 'showToast',
    value: function showToast() {
      var start = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
      var locale = this.props.locale;

      var content = start ? _locale2.default[locale].cascadeToastTip.start : _locale2.default[locale].cascadeToastTip.end;
      _Toast2.default.show({
        // className: prefixClass('day-calendar-cascade-tip'),
        duration: 1000,
        content: content
      });
    }
  }, {
    key: 'onDaySelected',
    value: function onDaySelected(timestamp) {
      var t = this;
      t.isASC = true;
      var _t$state$value = t.state.value,
          startDate = _t$state$value.startDate,
          endDate = _t$state$value.endDate,
          startDateType = _t$state$value.startDateType,
          endDateType = _t$state$value.endDateType;

      var activeType = '';
      if (!startDate && !endDate) {
        startDate = timestamp;
        startDateType = _const.halfDayType.FULL;
        endDateType = _const.halfDayType.FULL;
        activeType = 'start';
      } else if (!startDate && endDate) {
        if (timestamp > endDate) {
          startDate = endDate;
          endDate = timestamp;
          startDateType = _const.halfDayType.FULL;
          endDateType = _const.halfDayType.FULL;
          activeType = 'end';
        } else {
          startDate = timestamp;
          startDateType = _const.halfDayType.FULL;
          if (!endDateType || endDateType === 'PM') {
            endDateType = _const.halfDayType.FULL;
          }
          activeType = 'start';
          t.isASC = false;
        }
      } else if (startDate && !endDate) {
        if (timestamp < startDate) {
          endDate = startDate;
          startDate = timestamp;
          startDateType = _const.halfDayType.FULL;
          endDateType = _const.halfDayType.FULL;
          activeType = 'start';
          t.isASC = false;
        } else {
          endDate = timestamp;
          if (!startDateType || startDateType === 'AM') {
            startDateType = _const.halfDayType.FULL;
          }
          endDateType = _const.halfDayType.FULL;
          activeType = 'end';
        }
      } else if (startDate && endDate) {
        startDate = timestamp;
        endDate = null;
        startDateType = _const.halfDayType.FULL;
        endDateType = _const.halfDayType.FULL;
        activeType = 'start';
      }
      var newValue = _extends({}, t.state.value, {
        startDate: startDate,
        endDate: endDate,
        startDateType: startDateType,
        endDateType: endDateType
      });

      if (!newValue.startDate) {
        t.showToast(true);
      } else if (!newValue.endDate) {
        t.showToast(false);
      }

      t.setState({
        value: newValue,
        activeDate: timestamp,
        activeType: activeType
      });

      t.props.onChange({
        startDate: newValue.startDate,
        endDate: newValue.endDate,
        startDateType: newValue.startDateType,
        endDateType: newValue.endDateType
      });

      // 在 slide 模式，且不显示 halfDay 的情况下，只要起止值都已经完整，则触发 onOk
      if (t.props.animationType === 'slideLeft' && !t.props.showHalfDay && newValue.startDate && newValue.endDate) {
        t.props.onOk((0, _cloneDeep2.default)(newValue));
      }
    }
  }, {
    key: 'onHalfButtonClick',
    value: function onHalfButtonClick(halfType) {
      var t = this;
      var newValue = (0, _cloneDeep2.default)(t.state.value);
      newValue[t.state.activeType + 'DateType'] = halfType;
      this.setState({
        value: newValue
      });
      t.props.onChange((0, _cloneDeep2.default)(newValue));
    }
  }, {
    key: 'onOk',
    value: function onOk() {
      var t = this;
      t.props.onOk((0, _cloneDeep2.default)(t.state.value));
    }
  }, {
    key: 'renderHalfDay',
    value: function renderHalfDay() {
      var t = this;
      var locale = this.props.locale;

      var halfType = t.state.value[t.state.activeType + 'DateType'];

      var full = _react2.default.createElement(
        'li',
        {
          className: (0, _classnames2.default)((0, _Context.prefixClass)('tap'), 'day-type-item full', {
            active: halfType === _const.halfDayType.FULL
          }),
          key: 'half-day-full',
          onClick: function onClick(e) {
            t.onHalfButtonClick(_const.halfDayType.FULL, e);
          },
          role: 'menuitem'
        },
        _locale2.default[locale].dayTipMap.FULL
      );

      var am = _react2.default.createElement(
        'li',
        {
          className: (0, _classnames2.default)((0, _Context.prefixClass)('tap'), 'day-type-item am', {
            active: halfType === _const.halfDayType.AM
          }),
          key: 'half-day-am',
          onClick: function onClick(e) {
            t.onHalfButtonClick(_const.halfDayType.AM, e);
          },
          role: 'menuitem'
        },
        _locale2.default[locale].dayTipMap.AM
      );

      var pm = _react2.default.createElement(
        'li',
        {
          className: (0, _classnames2.default)((0, _Context.prefixClass)('tap'), 'day-type-item pm', {
            active: halfType === _const.halfDayType.PM
          }),
          key: 'half-day-pm',
          onClick: function onClick(e) {
            t.onHalfButtonClick(_const.halfDayType.PM, e);
          },
          role: 'menuitem'
        },
        _locale2.default[locale].dayTipMap.PM
      );

      var halfButtons = [full, am, pm];

      if (t.isASC && t.state.activeType === 'end') {
        halfButtons = [full, am];
      }
      if (!t.isASC && t.state.activeType === 'start') {
        halfButtons = [full, pm];
      }

      return _react2.default.createElement(
        'div',
        {
          className: (0, _Context.prefixClass)('day-calendar-half-day-wrapper')
        },
        _react2.default.createElement(
          'div',
          {
            className: (0, _Context.prefixClass)('day-calendar-half-day-container')
          },
          _react2.default.createElement(
            'ul',
            { className: 'day-type-list' },
            halfButtons
          )
        ),
        _react2.default.createElement(
          _Button2.default,
          {
            type: 'primary',
            display: 'banner',
            onClick: function onClick(e) {
              t.onOk(e);
            }
          },
          _locale2.default[locale].button.confirm
        )
      );
    }
  }], [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(props, state) {
      if (!(0, _isEqual2.default)(props.value, state.prevValue)) {
        return _extends({}, CascadePanel.processValue(props.value), {
          prevValue: props.value
        });
      }
      return null;
    }
  }]);

  return CascadePanel;
}(_Panel3.default);

CascadePanel.propTypes = _extends({}, _Panel3.default.propTypes);
CascadePanel.defaultProps = _extends({}, _Panel3.default.defaultProps);
exports.default = CascadePanel;
module.exports = exports['default'];