'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; /**
                                                                                                                                                                                                                                                                               * CascadeSelectField Component for SaltUI
                                                                                                                                                                                                                                                                               * @author caoke.ck
                                                                                                                                                                                                                                                                               *
                                                                                                                                                                                                                                                                               * Copyright 2018-2019, SaltUI Team.
                                                                                                                                                                                                                                                                               * All rights reserved.
                                                                                                                                                                                                                                                                               */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactLifecyclesCompat = require('react-lifecycles-compat');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames3 = require('classnames');

var _classnames4 = _interopRequireDefault(_classnames3);

var _cloneDeep = require('lodash/cloneDeep');

var _cloneDeep2 = _interopRequireDefault(_cloneDeep);

var _AngleRight = require('salt-icon/lib/AngleRight');

var _AngleRight2 = _interopRequireDefault(_AngleRight);

var _Context = require('../Context');

var _Context2 = _interopRequireDefault(_Context);

var _Slot = require('../Slot');

var _Slot2 = _interopRequireDefault(_Slot);

var _Field = require('../Field');

var _Field2 = _interopRequireDefault(_Field);

var _Popup = require('../Popup');

var _Popup2 = _interopRequireDefault(_Popup);

var _CascadeTab = require('./CascadeTab');

var _CascadeTab2 = _interopRequireDefault(_CascadeTab);

var _i18n = require('./i18n');

var _i18n2 = _interopRequireDefault(_i18n);

var _Utils = require('../Utils');

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function parseProps(props) {
  var options = props.options,
      readOnly = props.readOnly,
      mode = props.mode;

  var value = (0, _cloneDeep2.default)(props.value || []);
  // 过滤undefinded
  value = value.filter(function (i) {
    return i;
  });
  var cursor = options;
  var newOptions = [];
  var confirmedValue = value.length ? value : [];

  var _loop = function _loop(deep) {
    var index = 0;
    newOptions[deep] = cursor.map(function (o, i) {
      var option = void 0;
      if (mode === 'dynamic') {
        option = {
          value: o.value,
          text: o.label
        };
      } else {
        option = {
          value: o.value,
          text: o.label,
          defaultChecked: o.defaultChecked
        };
      }

      var val = value[deep];
      if ((typeof val === 'undefined' ? 'undefined' : _typeof(val)) === 'object' && 'value' in value[deep]) {
        val = value[deep].value;
      }
      if (o.value === val) {
        index = i;
        value[deep] = option;
      }
      return option;
    });
    var checkedCursor = cursor.find(function (o) {
      return o.defaultChecked;
    });

    if ((!value || !value.length) && checkedCursor) {
      cursor = checkedCursor.children;
    } else {
      cursor = cursor[index] ? cursor[index].children : null;
    }
  };

  for (var deep = 0; cursor; deep += 1) {
    _loop(deep);
  }
  // when its readOnly mode show whatever passed in values
  if (readOnly && options && options.length <= 0) {
    var values = value.map(function (v) {
      return { text: v, value: v };
    });
    return {
      options: [],
      value: values,
      confirmedValue: values,
      originOptions: options
    };
  }
  return {
    options: newOptions,
    value: value,
    confirmedValue: confirmedValue,
    originOptions: options
  };
}

function parseState(value, options) {
  // 过滤value，如果数组存在undefinded则过滤掉
  var filterdValue = value.filter(function (item) {
    return item;
  });
  var cursor = options;
  var newOptions = [];
  var newValue = (0, _cloneDeep2.default)(filterdValue);

  var _loop2 = function _loop2(deep) {
    var index = 0;
    var valueIsFound = false;
    newOptions[deep] = cursor.map(function (o, i) {
      var option = {
        value: o.value,
        text: o.label
      };
      if (deep in filterdValue && o.value === filterdValue[deep].value) {
        index = i;
        newValue[deep] = option;
        valueIsFound = true;
      }
      return option;
    });
    if (!valueIsFound) {
      var _newOptions$deep = _slicedToArray(newOptions[deep], 1);

      newValue[deep] = _newOptions$deep[0];
    }
    cursor = cursor[index] ? cursor[index].children : null;
  };

  for (var deep = 0; cursor; deep += 1) {
    _loop2(deep);
  }
  return {
    options: newOptions,
    value: newValue
  };
}

function findOption(target, origin) {
  var newOrigin = origin;
  for (var i = 0; i < newOrigin.length; i++) {
    if (target[0].value === newOrigin[i].value) {
      newOrigin[i].children = target[0].children;
    } else if (newOrigin[i].children) {
      newOrigin[i].children = findOption(target, newOrigin[i].children);
    }
  }
  return newOrigin;
}

function parseOptions(subOptions, currValue, oldOptions, oldOriginOptions) {
  if (subOptions[0].value === currValue[currValue.length - 1].value && subOptions[0].children.length !== 0) {
    var newOriginOptions = findOption(subOptions, oldOriginOptions);
    var newOptions = parseState(currValue, newOriginOptions);

    return {
      options: newOptions.options,
      originOptions: newOriginOptions,
      value: newOptions.value
    };
  }
  return {
    options: oldOptions,
    originOptions: oldOriginOptions,
    value: currValue
  };
}

var CascadeSelectField = function (_React$Component) {
  _inherits(CascadeSelectField, _React$Component);

  function CascadeSelectField(props) {
    _classCallCheck(this, CascadeSelectField);

    var _this = _possibleConstructorReturn(this, (CascadeSelectField.__proto__ || Object.getPrototypeOf(CascadeSelectField)).call(this, props));

    var t = _this;
    // 数据格式化
    t.state = parseProps(props);
    t.state.prevProps = props;
    t.state.popupVisible = false;
    t.state.confirmedValue = props.value ? t.state.value : [];
    t.handleClick = t.handleClick.bind(t);
    t.handleCancel = t.handleCancel.bind(t);
    t.handleChange = t.handleChange.bind(t);
    t.handleConfirm = t.handleConfirm.bind(t);
    return _this;
  }

  // 外部变更选中值


  _createClass(CascadeSelectField, [{
    key: 'handleClick',
    value: function handleClick() {
      var t = this;
      if (!t.props.readOnly && !t.props.disabled) {
        if (t.props.mode === 'normal') {
          t.slot.show();
        } else if (t.props.mode === 'complex' || 'dynamic') {
          this.showCascadeTab();
        }
      }
    }
  }, {
    key: 'showCascadeTab',
    value: function showCascadeTab() {
      var t = this;
      t.setState({
        popupVisible: true
      });
    }
  }, {
    key: 'hideCascadeTab',
    value: function hideCascadeTab() {
      var t = this;
      t.setState({
        popupVisible: false
      });
    }
  }, {
    key: 'handleChange',
    value: function handleChange(value) {
      var t = this;
      if (t.props.mode === 'dynamic') {
        this.props.onChange && this.props.onChange(value);
      }
      t.setState(parseState(value, t.props.options));
    }
  }, {
    key: 'handleConfirm',
    value: function handleConfirm(value) {
      var t = this;
      // 确认选中项目
      t.hideCascadeTab();
      t.props.onSelect(value);
    }
  }, {
    key: 'handleCancel',
    value: function handleCancel() {
      var t = this;
      if (t.state.confirmedValue.length) {
        t.setState(parseState(t.state.confirmedValue, t.props.options));
      } else {
        t.setState({ value: [] });
      }
      t.hideCascadeTab();
      t.props.onCancel();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var t = this;
      var icon = !t.props.readOnly ? _react2.default.createElement(_AngleRight2.default, {
        className: _Context2.default.prefixClass('cascade-select-field-icon'),
        width: 26,
        height: 26
      }) : null;
      return _react2.default.createElement(
        _Field2.default,
        _extends({}, t.props, {
          middleIcon: icon,
          className: (0, _classnames4.default)(_Context2.default.prefixClass('cascade-select-field'), _defineProperty({}, t.props.className, !!t.props.className)),
          onClick: t.handleClick
        }),
        _react2.default.createElement(
          'div',
          null,
          !t.state.confirmedValue.length ? _react2.default.createElement(
            'div',
            { className: _Context2.default.prefixClass('omit cascade-select-field-placeholder') },
            t.props.readOnly ? '' : t.props.placeholder
          ) : '',
          _react2.default.createElement(
            'div',
            { className: _Context2.default.prefixClass('cascade-select-field-value FBH FBAC') },
            _react2.default.createElement(
              'span',
              {
                className: (0, _classnames4.default)(_Context2.default.prefixClass('FB1 omit'), _defineProperty({}, _Context2.default.prefixClass('cascade-select-field-readonly'), !!t.props.readOnly))
              },
              t.props.formatter(t.state.confirmedValue)
            )
          )
        ),
        _react2.default.createElement(_Popup2.default, {
          content: _react2.default.createElement(_CascadeTab2.default, {
            title: t.props.label,
            locale: t.props.locale,
            confirmText: t.props.confirmText || _i18n2.default[t.props.locale].confirmText,
            cancelText: t.props.cancelText || _i18n2.default[t.props.locale].cancelText,
            options: t.state.originOptions,
            value: t.state.value,
            onChange: t.handleChange,
            onCancel: t.handleCancel,
            onConfirm: t.handleConfirm,
            activeTab: 'tab-' + t.props.activeTab,
            isDynamic: t.props.mode === 'dynamic',
            cascadeSize: t.props.cascadeSize
          }),
          stopBodyScrolling: false,
          visible: this.state.popupVisible,
          maskClosable: false
        }),
        this.props.mode === 'normal' ? _react2.default.createElement(_Slot2.default, {
          ref: function ref(c) {
            _this2.slot = c;
          },
          title: t.props.label,
          data: t.state.options,
          value: t.state.value,
          confirmText: t.props.confirmText || _i18n2.default[t.props.locale].confirmText,
          cancelText: t.props.cancelText || _i18n2.default[t.props.locale].cancelText,
          onChange: t.handleChange,
          onCancel: t.handleCancel,
          onConfirm: t.handleConfirm,
          columns: t.props.columns
        }) : null
      );
    }
  }], [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(nextProps, state) {
      if ((0, _Utils.shouldUpdate)(state.prevProps, nextProps, ['readOnly', 'options', 'value'])) {
        if (state.popupVisible) {
          return _extends({}, parseProps(nextProps), { prevProps: nextProps }, parseState(state.value, nextProps.options));
        }
        return _extends({}, parseProps(nextProps), { prevProps: nextProps });
      }
      return null;
    }
  }]);

  return CascadeSelectField;
}(_react2.default.Component);

CascadeSelectField.defaultProps = {
  options: [],
  value: [],
  formatter: function formatter(value) {
    return value.map(function (v) {
      return v.text;
    }).join('/');
  },
  onChange: function onChange() {},
  onSelect: function onSelect() {},
  onCancel: function onCancel() {},
  readOnly: false,
  placeholder: '',
  columns: [],
  mode: 'normal',
  locale: 'zh-cn',
  className: '',
  confirmText: undefined,
  cancelText: undefined,
  activeTab: 1,
  cascadeSize: 3
};

// http://facebook.github.io/react/docs/reusable-components.html
CascadeSelectField.propTypes = {
  className: _propTypes2.default.string,
  label: _propTypes2.default.string.isRequired,
  options: _propTypes2.default.array,
  value: _propTypes2.default.array,
  formatter: _propTypes2.default.func,
  onChange: _propTypes2.default.func,
  onSelect: _propTypes2.default.func,
  onCancel: _propTypes2.default.func,
  readOnly: _propTypes2.default.bool,
  placeholder: _propTypes2.default.string,
  confirmText: _propTypes2.default.string,
  cancelText: _propTypes2.default.string,
  columns: _propTypes2.default.array,
  locale: _propTypes2.default.string,
  mode: _propTypes2.default.oneOf(['normal', 'complex', 'dynamic']),
  activeTab: _propTypes2.default.number,
  cascadeSize: _propTypes2.default.oneOf([1, 2, 3, 4])
};

CascadeSelectField.displayName = 'CascadeSelectField';

(0, _reactLifecyclesCompat.polyfill)(CascadeSelectField);

exports.default = CascadeSelectField;
module.exports = exports['default'];