'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactLifecyclesCompat = require('react-lifecycles-compat');

var _Context = require('../Context');

var _Context2 = _interopRequireDefault(_Context);

var _index = require('./util/index');

var _index2 = _interopRequireDefault(_index);

var _Utils = require('../Utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Datetime Component for SaltUI
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author caoke.ck & shumi.lg
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @modify quanyun.mqy 于 2017.9.8 从 tingle-datetime-field 中分拆出来
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2014-2017, SaltUI Team.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var Slot = _index2.default.Slot,
    i18n = _index2.default.locale,
    getSlotFormattedValue = _index2.default.getSlotFormattedValue,
    needUpdateSlotValue = _index2.default.needUpdateSlotValue,
    getOptions = _index2.default.getOptions,
    getDaysByMonth = _index2.default.getDaysByMonth,
    addZero = _index2.default.addZero,
    formatFromProps = _index2.default.formatFromProps,
    formatText = _index2.default.formatText,
    isArray = _index2.default.isArray,
    isPlainObject = _index2.default.isPlainObject,
    filterDate = _index2.default.filterDate,
    parseValue = _index2.default.parseValue,
    Y = _index2.default.Y,
    YM = _index2.default.YM,
    YMD = _index2.default.YMD,
    YMDT = _index2.default.YMDT,
    YMDHM = _index2.default.YMDHM,
    YMDWHM = _index2.default.YMDWHM;


var columnsFlexMap = {
  YMD: [1.24, 1.1, 1.1],
  YMDT: [0.98, 0.83, 0.83, 0.79],
  YMDHm: [1.64, 0.89, 0.89],
  YMDWHm: [1.64, 0.89, 0.89]
};

var Datetime = function (_React$Component) {
  _inherits(Datetime, _React$Component);

  function Datetime(props) {
    _classCallCheck(this, Datetime);

    // 如果二者同时存在，是提示出错
    var _this = _possibleConstructorReturn(this, (Datetime.__proto__ || Object.getPrototypeOf(Datetime)).call(this, props));

    _this.getPlainDate = function (value) {
      var date = [];
      var columns = _this.props.columns;

      var timeType = 0;
      for (var i = 0; i < columns.length; i += 1) {
        if (columns[i] === 'Y') {
          date[0] = value[i].value;
        } else if (columns[i] === 'M') {
          date[1] = value[i].value;
        } else if (columns[i] === 'D') {
          date[2] = value[i].value;
        } else if (columns[i] === 'H') {
          date[3] = value[i].value;
        } else if (columns[i] === 'm') {
          date[4] = value[i].value;
        } else if (columns[i] === 's') {
          date[5] = value[i].value;
        } else if (columns[i] === 'T') {
          timeType = value[i].value;
        } else if (columns[i] === 'YMD' || columns[i] === 'YMDW') {
          if (value[1].value >= 12) {
            timeType = 1;
          }
          date[0] = ('' + value[i].value).substring(0, 4);
          date[1] = ('' + value[i].value).substring(4, 6) - 1;
          date[2] = ('' + value[i].value).substring(6, 8);
        }
      }
      // 如果需要显示上下午
      if (columns.indexOf('T') !== -1) {
        date[3] = timeType ? 18 : 9;
        date[4] = 0;
        date[5] = 0;
      }
      var passedDate = date.length === 1 ? date.concat([0]) : date;
      return {
        value: new (Function.prototype.bind.apply(Date, [null].concat(_toConsumableArray(passedDate))))().getTime(),
        timeType: timeType ? 'PM' : 'AM'
      };
    };

    _this.handleConfirm = function (value) {
      var onConfirm = _this.props.onConfirm;

      var outputDate = _this.getPlainDate(value);
      onConfirm(outputDate);
    };

    _this.handleCancel = function () {
      var onCancel = _this.props.onCancel;

      onCancel();
    };

    _this.handleChange = function (value) {
      var columnIndex = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var _this$props = _this.props,
          columns = _this$props.columns,
          minDate = _this$props.minDate,
          maxDate = _this$props.maxDate,
          disabledDate = _this$props.disabledDate,
          onChange = _this$props.onChange,
          locale = _this$props.locale;
      var stateData = _this.state.data;

      var columnsStyle = columns[columnIndex];
      var outputDate = _this.getPlainDate(value);
      // YMD,YMDT 等模式 更改最后一列时不做处理, Y,YM,YMDHM, YMDWHM 更任意一列都不做处理
      if (columns.length <= 2 || columns[0] !== 'Y' || columns.length === columnIndex + 1) {
        _this.setState({ value: value });
        onChange(outputDate);
        return;
      }
      var disabledArr = disabledDate ? disabledDate() : [];
      var data = [].concat(stateData);
      var yearData = data[0];
      var monthData = data[1];
      var yearValue = value[0].value;
      var monthValue = value[1].value;
      // disabledDate 仅支持 YMD、YMDT
      var updateObj = { value: value };
      if (isArray(disabledArr) && disabledArr.length && columns.length >= 3 && columns[0] === 'Y') {
        // TODO: FIXME 有 disabledArr 的逻辑里也存在 value 不在合理区间，导致获取的 options 不正确的问题，
        // 后续要参考没有 disabledArr 的逻辑进行修复。 by eternalsky@2019.01.02
        var newValue = parseValue(outputDate.value);
        var options = getOptions(outputDate.value, _this.props);
        var ret = Slot.formatDataValue([].concat(options), [].concat(newValue));
        var newData = formatFromProps(formatText(ret.data, undefined, _this.props), _this.props);
        var oldData = {};
        if (columnsStyle === 'Y') {
          oldData.yearData = yearData;
        }
        if (columnsStyle === 'M') {
          oldData.yearData = yearData;
          oldData.monthData = monthData;
        }
        var AllData = filterDate({
          data: newData,
          disabledArr: disabledArr,
          value: value,
          columns: columns,
          minDate: minDate,
          maxDate: maxDate,
          oldData: oldData,
          props: _this.props
        });
        updateObj.data = AllData;
      } else if (columnsStyle === 'Y' || columnsStyle === 'M') {
        updateObj = Datetime.getState(_extends({}, _this.props, { value: outputDate.value }));
      }
      _this.setState(updateObj);
    };

    if (props.columns.indexOf('T') !== -1 && props.columns.indexOf('H') !== -1) {
      throw new Error('Please refer to the component document.');
    }
    _this.state = Datetime.getState(props);
    _this.state = _extends({}, _this.state, { prevProps: props });
    return _this;
  }

  _createClass(Datetime, [{
    key: 'render',
    value: function render() {
      var props = this.props,
          state = this.state;
      var data = state.data,
          value = state.value;
      var locale = props.locale,
          confirmText = props.confirmText,
          cancelText = props.cancelText,
          title = props.title,
          slotRef = props.slotRef,
          columns = props.columns;

      return _react2.default.createElement(Slot, {
        className: _Context2.default.prefixClass('datetime-field-border-none'),
        ref: slotRef,
        columnsFlex: columnsFlexMap[columns.join('')],
        title: title,
        data: data,
        value: value,
        confirmText: confirmText || i18n[locale].confirmText,
        cancelText: cancelText || i18n[locale].cancelText,
        onChange: this.handleChange,
        onCancel: this.handleCancel,
        onConfirm: this.handleConfirm
      });
    }
  }], [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(props, state) {
      var keys = ['columns', 'minDate', 'maxDate', 'value', 'locale', 'columns'];
      if ((0, _Utils.shouldUpdate)(props, state.prevProps, keys)) {
        return _extends({}, Datetime.getState(props), {
          prevProps: props
        });
      }
      return null;
    }
  }, {
    key: 'getState',
    value: function getState(props) {
      var columns = props.columns,
          minDate = props.minDate,
          maxDate = props.maxDate;

      var validValue = Datetime.getValidValue(props);
      var currentValue = parseValue(validValue);
      var options = getOptions(validValue, props);
      var ret = Slot.formatDataValue([].concat(options), [].concat(currentValue));
      var data = formatFromProps(formatText(ret.data, undefined, props), props);
      var value = formatFromProps(formatText(ret.value, undefined, props), props);
      var columnsStyle = columns[0];
      // disabledDate 仅支持 YMD
      if (props.disabledDate && ['Y', 'YMD', 'YMDW'].indexOf(columnsStyle) !== -1) {
        var disabledArr = props.disabledDate();
        if (isArray(disabledArr) && disabledArr.length) {
          data = filterDate({
            data: data,
            disabledArr: disabledArr,
            value: value,
            columns: columns,
            minDate: minDate,
            maxDate: maxDate,
            props: props
          });

          var _Slot$formatDataValue = Slot.formatDataValue(data, value);

          value = _Slot$formatDataValue.value;
        }
      }
      return {
        data: data,
        value: value
      };
    }
  }, {
    key: 'getValidValue',
    value: function getValidValue(props) {
      var minDate = props.minDate,
          maxDate = props.maxDate,
          value = props.value;
      // value 为 undefined 时，new Date 返回为 invalid Date，与不传的效果不同

      var validValue = value ? new Date(isPlainObject(value) && value.value ? value.value : value).getTime() : new Date().getTime();
      var minStamp = new Date(minDate).getTime();
      var maxStamp = new Date(maxDate).getTime();
      if (validValue < minStamp) {
        return minStamp;
      }
      if (validValue > maxStamp) {
        return maxStamp;
      }
      return validValue;
    }
  }]);

  return Datetime;
}(_react2.default.Component);

Datetime.defaultProps = {
  className: '',
  locale: 'zh-cn',
  columns: YMD,
  onConfirm: function onConfirm(_) {
    return _;
  },
  onCancel: function onCancel(_) {
    return _;
  },
  onChange: function onChange(_) {
    return _;
  },
  slotRef: function slotRef(_) {
    return _;
  },
  minuteStep: 1,
  minDate: new Date(1900, 0, 1).getTime(),
  maxDate: new Date(2051, 0, 1).getTime() - 1,
  disabledDate: function disabledDate() {
    return [];
  },
  title: undefined,
  value: undefined,
  confirmText: undefined,
  cancelText: undefined,
  disabledTime: undefined
};

Datetime.propTypes = {
  className: _propTypes2.default.string,
  title: _propTypes2.default.string,
  locale: _propTypes2.default.string,
  columns: _propTypes2.default.array,
  value: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string, _propTypes2.default.object]),
  confirmText: _propTypes2.default.string,
  cancelText: _propTypes2.default.string,
  onConfirm: _propTypes2.default.func,
  onCancel: _propTypes2.default.func,
  onChange: _propTypes2.default.func,
  slotRef: _propTypes2.default.func,
  minuteStep: _propTypes2.default.number,
  maxDate: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
  minDate: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
  disabledDate: _propTypes2.default.func,
  disabledTime: _propTypes2.default.func
};

Datetime.Y = Y;
Datetime.YM = YM;
Datetime.YMD = YMD;
Datetime.YMDT = YMDT;
Datetime.YMDHM = YMDHM;
Datetime.YMDWHM = YMDWHM;
Datetime.getSlotFormattedValue = getSlotFormattedValue;
Datetime.needUpdateSlotValue = needUpdateSlotValue;
Datetime.displayName = 'Datetime';

(0, _reactLifecyclesCompat.polyfill)(Datetime);

exports.default = Datetime;
module.exports = exports['default'];