'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _cloneDeep = require('lodash/cloneDeep');

var _cloneDeep2 = _interopRequireDefault(_cloneDeep);

var _remove = require('lodash/remove');

var _remove2 = _interopRequireDefault(_remove);

var _PlusCircle = require('salt-icon/lib/PlusCircle');

var _PlusCircle2 = _interopRequireDefault(_PlusCircle);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _Context = require('../Context');

var _Context2 = _interopRequireDefault(_Context);

var _Field = require('../Field');

var _Field2 = _interopRequireDefault(_Field);

var _EmployeeList = require('./EmployeeList');

var _EmployeeList2 = _interopRequireDefault(_EmployeeList);

var _locale = require('./locale');

var _locale2 = _interopRequireDefault(_locale);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * EmployeeField Component for SaltUI
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author quanyun.mqy
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2018-2019, SaltUI Team.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var EmployeeField = function (_React$Component) {
  _inherits(EmployeeField, _React$Component);

  function EmployeeField() {
    _classCallCheck(this, EmployeeField);

    return _possibleConstructorReturn(this, (EmployeeField.__proto__ || Object.getPrototypeOf(EmployeeField)).apply(this, arguments));
  }

  _createClass(EmployeeField, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var Ali = window.Ali || {};
      if (Ali.ready) {
        Ali.ready(function () {
          _this2.forceUpdate();
        });
      }
    }
  }, {
    key: 'onPickHandler',
    value: function onPickHandler() {
      if (this.getReadOnly()) {
        return;
      }
      var _props = this.props,
          onPick = _props.onPick,
          multiple = _props.multiple,
          max = _props.max,
          isNeedSearch = _props.isNeedSearch,
          startWithDepartmentId = _props.startWithDepartmentId,
          value = _props.value,
          disabledUsers = _props.disabledUsers,
          enableAutoJumpDepart = _props.enableAutoJumpDepart,
          corpId = _props.corpId,
          enableNW = _props.enableNW,
          onChange = _props.onChange,
          apiOptions = _props.apiOptions;

      if (typeof onPick === 'function') {
        onPick();
        return;
      }
      var i18n = _locale2.default[this.props.locale];
      var option = _extends({
        multiple: multiple,
        max: max,
        isNeedSearch: isNeedSearch,
        startWithDepartmentId: startWithDepartmentId, //  SELF TOP
        // users: value.map(v => ({ emplId: v.key, name: v.label, nickNameCn: v.label })),
        users: value.map(function (v) {
          return v.key;
        }),
        disabledUsers: disabledUsers,
        enableAutoJumpDepart: enableAutoJumpDepart
      }, apiOptions);
      var Ali = window.Ali || {};
      if (window.Ali) {
        if (Ali.isDingDing) {
          if (!corpId) {
            Ali.alert({
              message: i18n.corpIdRequired,
              okButton: i18n.ok
            });
            return;
          }
          option.corpId = corpId;
        } else if (enableNW) {
          option.users = value.map(function (v) {
            return { emplId: v.key, name: v.label, nickNameCn: v.label };
          });
        }
        Ali.contacts.get(option, function (result) {
          if (result && !result.errorCode) {
            onChange((0, _utils.transToValue)(result.results));
          } else {
            Ali.alert({
              message: result.errorMessage,
              okButton: i18n.ok
            });
          }
        });
      } else if (window.dd) {
        // fall back to dd api
        window.dd.biz.contact.complexPicker(_extends({}, option, {
          pickedUsers: option.users,
          maxUsers: option.max,
          startWithDepartmentId: 0,
          showRootOrg: true,
          corpId: corpId
        }, apiOptions, {
          onSuccess: function onSuccess(result) {
            onChange((0, _utils.transToValue)(result.users));
          },
          onFail: function onFail(err) {
            window.dd.device.notification.alert({
              message: err.message,
              buttonName: i18n.ok
            });
          }
        }));
      }
    }
  }, {
    key: 'onItemDel',
    value: function onItemDel(key) {
      var list = (0, _cloneDeep2.default)(this.props.value);
      (0, _remove2.default)(list, function (item) {
        return item.key === key;
      });
      this.props.onChange(list);
    }
  }, {
    key: 'getTotalText',
    value: function getTotalText() {
      var i18n = _locale2.default[this.props.locale];
      return i18n.getTotalText(this.props.value.length);
    }
  }, {
    key: 'getReadOnly',
    value: function getReadOnly() {
      var nativeEnabled = this.isNativeEnabled();
      if (!nativeEnabled) {
        return true;
      }
      return this.props.readOnly;
    }
  }, {
    key: 'isNativeEnabled',
    value: function isNativeEnabled() {
      if (typeof window === 'undefined') {
        return false;
      }
      if (window.dd) {
        return true;
      }
      if (window.Ali && window.Ali.isAliwork && this.props.enableNW) {
        return true;
      }
      return false;
    }
  }, {
    key: 'renderEmployeeList',
    value: function renderEmployeeList() {
      var _this3 = this;

      var onAvatarClick = this.props.onAvatarClick;

      return _react2.default.createElement(_EmployeeList2.default, {
        readOnly: this.getReadOnly(),
        list: this.props.value,
        onDel: function onDel(id) {
          _this3.onItemDel(id);
        },
        onClick: onAvatarClick
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var t = this;
      var iconProps = {
        className: (0, _classnames3.default)(_Context2.default.prefixClass('employee-field-icon'), {
          active: !t.getReadOnly()
        }),
        width: 20,
        height: 20,
        onClick: function onClick(e) {
          t.onPickHandler(e);
        }
      };

      var icon = !t.getReadOnly() ? _react2.default.createElement(_PlusCircle2.default, iconProps) : null;

      var _t$props = t.props,
          className = _t$props.className,
          tip = _t$props.tip,
          otherProps = _objectWithoutProperties(_t$props, ['className', 'tip']);

      delete otherProps.layout;
      var i18n = _locale2.default[this.props.locale];

      var modifiedTip = this.isNativeEnabled() ? tip : _react2.default.createElement(
        'div',
        null,
        i18n.readOnly,
        tip
      );

      return _react2.default.createElement(
        'div',
        {
          className: (0, _classnames3.default)(_Context2.default.prefixClass('employee-field'), _defineProperty({}, className, !!className))
        },
        _react2.default.createElement(_Field2.default, _extends({}, otherProps, {
          labelRight: _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(
              'div',
              { className: (0, _classnames3.default)(_Context2.default.prefixClass('employee-field-placeholder-wrapper'), 'needsclick'), onClick: function onClick(e) {
                  t.onPickHandler(e);
                } },
              !t.props.value.length ? _react2.default.createElement(
                'div',
                { className: _Context2.default.prefixClass('omit employee-field-placeholder') },
                t.props.placeholder
              ) : _react2.default.createElement(
                'div',
                { className: _Context2.default.prefixClass('omit employee-field-num') },
                t.getTotalText()
              )
            ),
            icon
          ),
          tip: modifiedTip,
          layout: 'v'
        })),
        t.renderEmployeeList()
      );
    }
  }]);

  return EmployeeField;
}(_react2.default.Component);

EmployeeField.displayName = 'EmployeeField';
EmployeeField.propTypes = {
  className: _propTypes2.default.string,
  corpId: _propTypes2.default.string,
  placeholder: _propTypes2.default.string,
  multiple: _propTypes2.default.bool,
  max: _propTypes2.default.number,
  isNeedSearch: _propTypes2.default.bool,
  locale: _propTypes2.default.string,
  startWithDepartmentId: _propTypes2.default.number,
  readOnly: _propTypes2.default.bool,
  value: _propTypes2.default.array,
  disabledUsers: _propTypes2.default.array,
  onChange: _propTypes2.default.func,
  onAvatarClick: _propTypes2.default.func,
  enableNW: _propTypes2.default.bool,
  onPick: _propTypes2.default.func,
  enableAutoJumpDepart: _propTypes2.default.bool,
  apiOptions: _propTypes2.default.object
};
EmployeeField.defaultProps = {
  placeholder: '',
  multiple: true,
  max: 100,
  isNeedSearch: true,
  locale: 'zh-cn',
  startWithDepartmentId: -1,
  readOnly: false,
  enableNW: false,
  value: [],
  disabledUsers: [],
  onChange: function onChange() {},
  onAvatarClick: function onAvatarClick() {},
  className: undefined,
  corpId: undefined,
  onPick: undefined,
  enableAutoJumpDepart: true,
  apiOptions: {}
};
exports.default = EmployeeField;
module.exports = exports['default'];