'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
// 把 钉钉api 返回的值转换成 key/label 格式
function transToValue(list) {
  return (list || []).map(function (item) {
    var emplId = item.emplId,
        nick = item.nick,
        nickNameCn = item.nickNameCn,
        name = item.name,
        orgUserName = item.orgUserName,
        avatar = item.avatar;


    var nickName = nick || nickNameCn;
    var label = '';
    if (nickName) {
      // 花名(工号)
      label = nickName + '(' + emplId + ')';
    } else if (orgUserName) {
      // 姓名(工号)
      label = orgUserName + '(' + emplId + ')';
    } else if (name) {
      // name = 姓名(花名)
      label = (name || '').replace('（', '(').replace('）', ')');
    }

    return {
      key: emplId,
      label: label,
      avatar: avatar
    };
  });
}

exports.default = { transToValue: transToValue };
module.exports = exports['default'];