'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _FilterBar = require('./FilterBar');

var _FilterBar2 = _interopRequireDefault(_FilterBar);

var _FilterPanel = require('./FilterPanel');

var _FilterPanel2 = _interopRequireDefault(_FilterPanel);

var _Context = require('../Context');

var _Context2 = _interopRequireDefault(_Context);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _Mask = require('../Mask');

var _Mask2 = _interopRequireDefault(_Mask);

var _Filter = require('salt-icon/lib/Filter');

var _Filter2 = _interopRequireDefault(_Filter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Filter Component for SaltUI
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author taoqili
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2018-2019, SaltUI Team.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var Filter = function (_React$Component) {
  _inherits(Filter, _React$Component);

  function Filter(props) {
    _classCallCheck(this, Filter);

    var _this = _possibleConstructorReturn(this, (Filter.__proto__ || Object.getPrototypeOf(Filter)).call(this, props));

    _this.setSelect = function () {
      var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var ignoreOnChange = arguments[1];

      var name = Object.keys(data)[0];
      var onChange = _this.props.onChange;

      _this.selectData = _extends({}, _this.selectData, data);
      !ignoreOnChange && onChange({
        name: name,
        currentSelected: data[name],
        allSelected: _this.getSelect()
      }, _this);
    };

    _this.getSelect = function (name) {
      var data = _this.selectData;
      Object.keys(_this.selectData).map(function (name) {
        if (!data[name] || !data[name].length) {
          delete data[name];
        }
      });
      return !name ? data : data[name];
    };

    _this.getActiveIndex = function () {
      return _this.state.activeIndex;
    };

    _this.setActiveIndex = function (index) {
      _this.setState({
        activeIndex: index
      });
      if (index === -1) {
        _this.setState({
          maskVisible: false
        });
      }
    };

    _this.handleMask = function (isShow, group) {
      _this.setState({
        maskVisible: isShow && group.type !== 'switch' && group.type !== 'super'
      });
    };

    _this.setMaskOffset = function (offset) {
      _this.setState({
        maskOffset: offset
      });
    };

    _this.handleMaskClick = function () {
      var onConfirm = _this.props.onConfirm;

      var options = _this.formatOptions();
      var group = options.groups[_this.state.activeIndex];
      if (group && group.multiSelect) {
        onConfirm(_this.getSelect(), _this);
      }
      _this.setState({
        activeIndex: -1,
        maskVisible: false
      });
    };

    _this.formatOptions = function () {
      var _this$props = _this.props,
          size = _this$props.size,
          options = _this$props.options;

      var maxSize = size > 4 ? 4 : size;
      if (options.length <= maxSize) {
        return {
          maxSize: maxSize,
          groups: options,
          _backItems: options
        };
      }
      var newFilterGroups = [].concat(_toConsumableArray(options));
      return {
        maxSize: maxSize,
        groups: [].concat(_toConsumableArray(newFilterGroups.splice(0, maxSize - 1)), [{
          name: '_super_',
          title: '高级筛选',
          icon: _react2.default.createElement(_Filter2.default, {
            width: 12,
            height: 12,
            className: 'icon'
          }),
          type: 'super',
          children: [].concat(_toConsumableArray(newFilterGroups.map(function (item) {
            item._groupKey_ = '_super_';
            return item;
          })))
        }]),
        _backItems: options
      };
    };

    _this.selectData = {};
    if (props.defaultValue) {
      _this.setSelect(props.defaultValue, true);
    }
    _this.state = {
      activeIndex: props.activeIndex,
      maskVisible: false,
      maskOffset: 0
    };
    return _this;
  }

  _createClass(Filter, [{
    key: 'clearValue',
    value: function clearValue(name) {
      if (!name) {
        this.selectData = {};
      }
      delete this.selectData[name];
    }
  }, {
    key: 'setValue',
    value: function setValue(name, data) {
      if (!name || !data || !data.length) {
        return;
      }
      this.setSelect(_defineProperty({}, name, data));
    }
  }, {
    key: 'getValue',
    value: function getValue(name) {
      return this.getSelect(name);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var options = this.formatOptions();
      var _state = this.state,
          activeIndex = _state.activeIndex,
          maskVisible = _state.maskVisible,
          maskOffset = _state.maskOffset;

      var props = _extends({}, this.props, {
        activeIndex: activeIndex,
        options: options,
        setSelect: this.setSelect,
        getSelect: this.getSelect,
        getActiveIndex: this.getActiveIndex,
        setActiveIndex: this.setActiveIndex,
        handleMask: this.handleMask,
        setMaskOffset: this.setMaskOffset,
        onConfirm: function onConfirm(data) {
          _this2.props.onConfirm(data, _this2);
        },
        onReset: function onReset(data) {
          _this2.props.onReset(data, _this2);
        },
        onChange: function onChange(data) {
          _this2.props.onChange(data, _this2);
        }

      });
      return _react2.default.createElement(
        'div',
        { className: (0, _classnames3.default)(_Context2.default.prefixClass('filter-wrapper'), _defineProperty({}, props.className, !!props.className)) },
        _react2.default.createElement(_FilterBar2.default, props),
        _react2.default.createElement(_FilterPanel2.default, props),
        _react2.default.createElement(_Mask2.default, {
          visible: maskVisible,
          opacity: 0.4,
          zIndex: 800,
          topOffset: maskOffset + 'px',
          onClick: this.handleMaskClick
        })
      );
    }
  }]);

  return Filter;
}(_react2.default.Component);

Filter.displayName = 'Filter';
Filter.propTypes = {
  className: _propTypes2.default.string,
  options: _propTypes2.default.array,
  size: _propTypes2.default.oneOf([1, 2, 3, 4]),
  activeIndex: _propTypes2.default.number,
  onChange: _propTypes2.default.func,
  onConfirm: _propTypes2.default.func,
  onReset: _propTypes2.default.func,
  value: _propTypes2.default.object
};
Filter.defaultProps = {
  className: undefined,
  options: [],
  size: 4,
  activeIndex: -1,
  value: null,
  onChange: function onChange() {},
  onConfirm: function onConfirm() {},
  onReset: function onReset() {}
};
exports.default = Filter;
module.exports = exports['default'];