'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Context = require('../Context');

var _Context2 = _interopRequireDefault(_Context);

var _Boxs = require('../Boxs');

var _AngleUp = require('salt-icon/lib/AngleUp');

var _AngleUp2 = _interopRequireDefault(_AngleUp);

var _AngleDown = require('salt-icon/lib/AngleDown');

var _AngleDown2 = _interopRequireDefault(_AngleDown);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FilterBar = function (_React$Component) {
  _inherits(FilterBar, _React$Component);

  function FilterBar(props) {
    _classCallCheck(this, FilterBar);

    var _this = _possibleConstructorReturn(this, (FilterBar.__proto__ || Object.getPrototypeOf(FilterBar)).call(this, props));

    _this.state = {
      activeIndex: props.activeIndex
    };
    return _this;
  }

  _createClass(FilterBar, [{
    key: 'getMaskOffset',
    value: function getMaskOffset() {
      var filterBar = _reactDom2.default.findDOMNode(this.filterBar);
      var rect = filterBar.getBoundingClientRect();
      return rect.top;
    }
  }, {
    key: 'changeActiveIndex',
    value: function changeActiveIndex(group, index) {
      var activeIndex = this.state.activeIndex;
      var _props = this.props,
          setActiveIndex = _props.setActiveIndex,
          handleMask = _props.handleMask,
          setMaskOffset = _props.setMaskOffset;

      var isFocus = activeIndex !== index;
      var newIndex = !isFocus ? -1 : index;
      setActiveIndex(newIndex);
      if (group.type === 'switch') {
        this.doSwitchFilter(group);
      }
      setMaskOffset(this.getMaskOffset());
      handleMask(isFocus, group);
      this.setState({
        activeIndex: newIndex
      });
    }
  }, {
    key: 'doSwitchFilter',
    value: function doSwitchFilter(group) {
      var _props2 = this.props,
          getSelect = _props2.getSelect,
          setSelect = _props2.setSelect,
          onConfirm = _props2.onConfirm;
      var name = group.name,
          items = group.items;

      var currentSelectData = getSelect()[name];
      setSelect(_defineProperty({}, name, currentSelectData && currentSelectData.length ? null : items));
      onConfirm(getSelect());
    }
  }, {
    key: 'renderTitle',
    value: function renderTitle(group, index) {
      var activeIndex = this.state.activeIndex;
      var getSelect = this.props.getSelect;

      var currentSelectData = getSelect()[group.name];
      var isFocus = group.type !== 'switch' ? activeIndex === index : currentSelectData && currentSelectData.length && activeIndex === index;
      var isFlag = this.checkFlag(group, index);
      var title = typeof group.title === 'function' ? _react2.default.createElement(
        'span',
        null,
        group.title(isFocus, currentSelectData)
      ) : _react2.default.createElement(
        'span',
        null,
        isFlag && currentSelectData ? currentSelectData.length > 1 ? group.title : currentSelectData.length === 1 ? currentSelectData[0].text : group.title : group.title
      );
      return _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('title-wrapper', {
            active: isFocus,
            selected: isFlag && (group.name === '_super_' || currentSelectData && currentSelectData.length)
          })
        },
        title
      );
    }
  }, {
    key: 'renderIcon',
    value: function renderIcon(group, index) {
      var activeIndex = this.state.activeIndex;

      var isFocus = activeIndex === index;
      var getSelect = this.props.getSelect;

      var currentSelectData = getSelect()[group.name];
      var isFlag = this.checkFlag(group, index);
      var iconProps = {
        width: group.type === 'super' ? 12 : 20,
        height: group.type === 'super' ? 12 : 20,
        className: 'icon'
      };
      var icon = group.icon || (isFocus ? _react2.default.createElement(_AngleUp2.default, iconProps) : _react2.default.createElement(_AngleDown2.default, iconProps));
      return group.icon !== false ? _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)("icon-wrapper", {
            active: isFocus,
            selected: isFlag && (group.name === '_super_' || currentSelectData && currentSelectData.length)
          })
        },
        icon
      ) : null;
    }
  }, {
    key: 'checkFlag',
    value: function checkFlag(group, index) {
      var _props3 = this.props,
          getSelect = _props3.getSelect,
          options = _props3.options;
      var name = group.name;
      var groups = options.groups;

      var selectData = getSelect();
      var flag = false;
      if (group.name !== '_super_') {
        flag = selectData[name] && selectData[name].length;
      } else {
        var children = groups[index].children;
        for (var i = 0; i < children.length; i++) {
          var childName = children[i].name;
          for (var j in selectData) {
            if (selectData.hasOwnProperty(j)) {
              if (childName === j) {
                var s = selectData[j];
                if (s && s.length) {
                  flag = true;
                  break;
                }
              }
            }
          }
          if (flag) {
            break;
          }
        }
      }
      return flag;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var options = this.props.options;
      var groups = options.groups;

      return _react2.default.createElement(
        'div',
        { ref: function ref(c) {
            _this2.filterBar = c;
          } },
        _react2.default.createElement(
          _Boxs.HBox,
          { className: _Context2.default.prefixClass('filter-bar-wrapper') },
          groups.map(function (group, index) {
            return _react2.default.createElement(
              _Boxs.Box,
              {
                key: group.name,
                className: 'item',
                flex: 1,
                hAlign: 'center',
                onClick: function onClick() {
                  _this2.changeActiveIndex(group, index);
                }
              },
              _react2.default.createElement(
                'div',
                { className: (0, _classnames2.default)(_Context2.default.prefixClass('FBH'), 'item-wrapper') },
                _this2.renderTitle(group, index),
                _this2.renderIcon(group, index)
              )
            );
          })
        )
      );
    }
  }], [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if (nextProps.activeIndex !== prevState.activeIndex) {
        return {
          activeIndex: nextProps.activeIndex
        };
      }
      return null;
    }
  }]);

  return FilterBar;
}(_react2.default.Component);

FilterBar.displayName = 'FilterBar';
FilterBar.propTypes = {
  options: _propTypes2.default.object,
  setSelect: _propTypes2.default.func,
  onChange: _propTypes2.default.func,
  getSelect: _propTypes2.default.func
};
FilterBar.defaultProps = {
  options: {},
  setSelect: function setSelect() {},
  onChange: function onChange() {},
  getSelect: function getSelect() {}
};
exports.default = FilterBar;
module.exports = exports['default'];