'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _Context = require('../Context/Context');

var _Context2 = _interopRequireDefault(_Context);

var _Popup = require('../Popup');

var _Popup2 = _interopRequireDefault(_Popup);

var _Check = require('salt-icon/lib/Check');

var _Check2 = _interopRequireDefault(_Check);

var _AngleRight = require('salt-icon/lib/AngleRight');

var _AngleRight2 = _interopRequireDefault(_AngleRight);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _classnames3 = require('classnames');

var _classnames4 = _interopRequireDefault(_classnames3);

var _cloneDeep = require('lodash/cloneDeep');

var _cloneDeep2 = _interopRequireDefault(_cloneDeep);

var _Grid = require('../Grid');

var _Grid2 = _interopRequireDefault(_Grid);

var _Picker = require('../Picker');

var _Picker2 = _interopRequireDefault(_Picker);

var _Switch = require('../Switch');

var _Switch2 = _interopRequireDefault(_Switch);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FilterPanel = function (_React$Component) {
  _inherits(FilterPanel, _React$Component);

  function FilterPanel(props) {
    _classCallCheck(this, FilterPanel);

    var _this = _possibleConstructorReturn(this, (FilterPanel.__proto__ || Object.getPrototypeOf(FilterPanel)).call(this, props));

    _this.onItemClick = function (e) {
      var target = e.currentTarget;
      var name = target.getAttribute('data-name');
      var multiSelect = target.getAttribute('data-multi');
      var value = target.getAttribute('data-value');
      var text = target.getAttribute('data-text');
      var classList = target.classList;

      if (!value || value === 'showAll') {
        _this.showAll(name);
        return;
      }
      if (multiSelect === 'false') {
        var itemParentNode = _reactDom2.default.findDOMNode(_this.grids[name]);
        var items = itemParentNode.querySelectorAll('.' + _Context2.default.prefixClass('filter-grid-item')) || [];
        items.forEach(function (item) {
          if (item.getAttribute('data-value') !== value) {
            item.classList.remove('active');
          }
        });
      }
      classList.toggle('active');
      _this.doItemFilter({ value: value, text: text, name: name });
    };

    _this.onOrderItemClick = function (e) {
      var target = e.currentTarget;
      var name = target.getAttribute('data-name');
      var value = target.getAttribute('data-value');
      var text = target.getAttribute('data-text');
      var classList = target.classList;
      var getSelect = _this.props.getSelect;

      var currentSelectData = getSelect();
      if (!currentSelectData[name] || !currentSelectData[name].value) {
        _this.doItemFilter({ value: value, text: text, name: name });
        classList.toggle('toggle');
        return;
      }
      if (value === currentSelectData[name][0].value) {
        return;
      }
      var parent = target.parentElement;
      var items = parent.querySelectorAll('.' + _Context2.default.prefixClass('filter-grid-item')) || [];
      items.forEach(function (item) {
        if (item.getAttribute('data-value') !== value) {
          item.classList.remove('active');
        }
      });
      _this.doItemFilter({ value: value, text: text, name: name });
      classList.toggle('toggle');
    };

    _this.state = {
      showPicker: false,
      pickerOptions: [],
      multiple: false,
      name: '',
      value: []
    };
    _this.grids = {};
    return _this;
  }

  _createClass(FilterPanel, [{
    key: 'showAll',
    value: function showAll(name) {
      console.log('showAll');
      var _props = this.props,
          options = _props.options,
          getSelect = _props.getSelect;
      var _backItems = options._backItems;

      var currentData = getSelect()[name];
      var pick = _backItems.find(function (item) {
        return item.name === name;
      }) || {};

      this.setState({
        name: name,
        showPicker: true,
        pickerOptions: pick.items || [],
        multiple: pick.multiSelect,
        value: currentData
      });
    }
  }, {
    key: 'doItemFilter',
    value: function doItemFilter(_ref) {
      var value = _ref.value,
          text = _ref.text,
          name = _ref.name;
      var _props2 = this.props,
          options = _props2.options,
          setSelect = _props2.setSelect,
          getSelect = _props2.getSelect,
          onConfirm = _props2.onConfirm,
          setActiveIndex = _props2.setActiveIndex;
      var _backItems = options._backItems;

      var group = _backItems.find(function (item) {
        return item.name === name;
      });
      var selectData = getSelect();
      var currentSelectData = selectData[name] || [];
      if (group.multiSelect === false || group.type === 'order') {
        if (currentSelectData.length) {
          setSelect(_defineProperty({}, name, null), true);
        }
        setSelect(_defineProperty({}, name, !currentSelectData.length || currentSelectData[0].value !== value ? [{ text: text, value: value }] : null));
        if (group._groupKey_ !== '_super_' || group.type === 'order') {
          setActiveIndex(-1);
          onConfirm(getSelect());
        }
      } else {
        var hasSelected = currentSelectData.find(function (item) {
          return item.value === value;
        });

        if (!hasSelected) {
          setSelect(_defineProperty({}, name, [].concat(_toConsumableArray(currentSelectData), [{ value: value, text: text }])));
        } else {
          setSelect(_defineProperty({}, name, currentSelectData.filter(function (item) {
            return item.value !== value;
          })));
        }
      }
    }
  }, {
    key: 'renderRange',
    value: function renderRange(group) {
      var getSelect = this.props.getSelect;
      var name = group.name,
          items = group.items;

      var currentSelectData = getSelect()[name];
      return _react2.default.createElement(
        'div',
        null,
        '112321'
      );
    }
  }, {
    key: 'renderOrder',
    value: function renderOrder(group) {
      var _this2 = this;

      var getSelect = this.props.getSelect;
      var name = group.name,
          items = group.items;

      var currentSelectData = getSelect()[name];
      if (!currentSelectData || !currentSelectData[0] || !currentSelectData[0].value) {
        currentSelectData = [items[0]];
      }
      return _react2.default.createElement(
        'div',
        null,
        items.map(function (item) {
          var _classnames;

          var isSelected = false;
          if (currentSelectData && currentSelectData[0]) {
            isSelected = currentSelectData[0].value === item.value;
          }
          return _react2.default.createElement(
            'div',
            {
              key: item.value,
              className: (0, _classnames4.default)((_classnames = {}, _defineProperty(_classnames, _Context2.default.prefixClass('filter-list-item'), true), _defineProperty(_classnames, 'active', isSelected), _classnames)),
              'data-name': name,
              'data-value': item.value,
              'data-text': typeof item.text === 'string' ? item.text : typeof item.text === 'function' ? item.text().toString() : '',
              onClick: _this2.onOrderItemClick
            },
            typeof item.text === 'string' ? item.text : typeof item.text === 'function' ? item.text() : '',
            isSelected ? _react2.default.createElement(_Check2.default, { className: 'icon', width: 20, height: 20 }) : null
          );
        })
      );
    }
  }, {
    key: 'renderSelectTitle',
    value: function renderSelectTitle(group) {
      var tip = group.tip;

      return tip ? _react2.default.createElement(
        'p',
        { className: _Context2.default.prefixClass('filter-group-title') },
        tip
      ) : null;
    }
  }, {
    key: 'renderSelectFooter',
    value: function renderSelectFooter(group) {
      var _this3 = this;

      var _groupKey_ = group._groupKey_,
          multiSelect = group.multiSelect;

      if (_groupKey_ !== '_super_' && multiSelect !== false) {
        return _react2.default.createElement(
          'div',
          { className: _Context2.default.prefixClass('filter-grid-footer') },
          _react2.default.createElement(
            _Button2.default.Group,
            null,
            _react2.default.createElement(
              _Button2.default,
              { type: 'secondary', display: 'inline', onClick: function onClick() {
                  _this3.resetSelect(group.name);
                } },
              '\u91CD \u7F6E'
            ),
            _react2.default.createElement(
              _Button2.default,
              { type: 'primary', display: 'inline', onClick: function onClick() {
                  _this3.confirm();
                } },
              '\u786E \u5B9A'
            )
          )
        );
      }
    }
  }, {
    key: 'renderSelect',
    value: function renderSelect(group) {
      var _this4 = this;

      var getSelect = this.props.getSelect;
      var items = group.items,
          maxLine = group.maxLine,
          name = group.name,
          multiSelect = group.multiSelect;

      var currentSelectData = getSelect()[name];

      var max = maxLine || 4;
      var renderItems = void 0;
      if (items.length > 3 * max) {
        renderItems = (0, _cloneDeep2.default)(items);
        renderItems.length = 3 * max - 1;
        renderItems.push({
          value: 'showAll',
          text: function text() {
            return _react2.default.createElement(
              'div',
              { 'data-name': name },
              _react2.default.createElement(
                'span',
                null,
                '\u5168\u90E8'
              ),
              _react2.default.createElement(_AngleRight2.default, { className: _Context2.default.prefixClass('filter-show-all-icon'), width: 20, height: 20, fill: '#555' })
            );
          }
        });
      } else {
        renderItems = items;
      }
      return _react2.default.createElement(
        'div',
        { className: _Context2.default.prefixClass('filter-grid-row') },
        this.renderSelectTitle(group),
        _react2.default.createElement(
          _Grid2.default,
          { col: 3, noLine: true, ref: function ref(c) {
              _this4.grids[name] = c;
            } },
          renderItems.map(function (item) {
            var _classnames2;

            var isSelected = false;
            if (currentSelectData && currentSelectData.find(function (i) {
              return i.value === item.value;
            })) {
              isSelected = true;
            }
            return _react2.default.createElement(
              'div',
              {
                className: (0, _classnames4.default)((_classnames2 = {}, _defineProperty(_classnames2, _Context2.default.prefixClass('filter-grid-item'), true), _defineProperty(_classnames2, 'active', isSelected), _classnames2)),
                key: item.value,
                'data-name': name,
                'data-multi': multiSelect,
                'data-value': item.value,
                'data-text': typeof item.text === 'string' ? item.text : typeof item.text === 'function' ? item.text().toString() : '',
                onClick: _this4.onItemClick
              },
              typeof item.text === 'string' ? item.text : typeof item.text === 'function' ? item.text() : ''
            );
          })
        ),
        this.renderSelectFooter(group),
        this.renderPicker()
      );
    }
  }, {
    key: 'resetSuper',
    value: function resetSuper() {
      var _props3 = this.props,
          setSelect = _props3.setSelect,
          getSelect = _props3.getSelect,
          options = _props3.options;
      var children = options.groups[options.groups.length - 1].children;

      var selectData = getSelect();
      var resetNames = [];
      children.forEach(function (item) {
        if (selectData[item.name]) {
          resetNames.push(item.name);
          setSelect(_defineProperty({}, item.name, null));
        }
      });
      this.reset(resetNames);
    }
  }, {
    key: 'resetSelect',
    value: function resetSelect(name) {
      var setSelect = this.props.setSelect;

      setSelect(_defineProperty({}, name, null));
      this.reset([name]);
    }
  }, {
    key: 'reset',
    value: function reset(names) {
      var _props4 = this.props,
          onReset = _props4.onReset,
          setActiveIndex = _props4.setActiveIndex,
          getSelect = _props4.getSelect,
          onConfirm = _props4.onConfirm;

      setActiveIndex(-1);
      var selected = getSelect();
      onReset({
        resetNames: names,
        allSelected: selected
      });
      onConfirm(selected);
    }
  }, {
    key: 'confirm',
    value: function confirm() {
      var _props5 = this.props,
          onConfirm = _props5.onConfirm,
          getSelect = _props5.getSelect,
          setActiveIndex = _props5.setActiveIndex;

      setActiveIndex(-1);
      onConfirm(getSelect());
    }
  }, {
    key: 'handleSwitchChange',
    value: function handleSwitchChange(group, isOn) {
      var setSelect = this.props.setSelect;

      setSelect(_defineProperty({}, group.name, !isOn ? null : [group.items[0]]));
    }
  }, {
    key: 'renderPicker',
    value: function renderPicker() {
      var _this5 = this;

      var _state = this.state,
          showPicker = _state.showPicker,
          pickerOptions = _state.pickerOptions,
          multiple = _state.multiple,
          name = _state.name,
          value = _state.value;
      var setSelect = this.props.setSelect;

      return _react2.default.createElement(_Picker2.default, {
        value: value,
        options: pickerOptions,
        multiple: multiple,
        showSearch: false,
        onConfirm: function onConfirm(value) {
          if (!multiple) {
            _this5.doItemFilter({ value: value[0].value, text: value[0].text, name: name });
          } else {
            setSelect(_defineProperty({}, name, value));
          }
          _this5.setState({
            showPicker: false
          });
        },
        confirmText: '确认',
        filterOption: false,
        onVisibleChange: function onVisibleChange(visible) {
          if (!visible) {
            _this5.setState({
              showPicker: false
            });
          }
        },
        onSearch: function onSearch(keyword) {
          // const items = pickerOptions.find(item => {
          //   return item.text.indexOf(keyword !== -1)
          // });
          // this.setState({
          //   pickerOptions: items
          // });
        },
        visible: showPicker
      });
    }
  }, {
    key: 'renderCustomView',
    value: function renderCustomView(item) {
      var _this6 = this;

      var View = item.renderView;
      var _props6 = this.props,
          setSelect = _props6.setSelect,
          getSelect = _props6.getSelect,
          setActiveIndex = _props6.setActiveIndex;

      return _react2.default.createElement(
        'div',
        { key: item.name },
        _react2.default.createElement(View, {
          name: item.name,
          selectedDate: getSelect(),
          onChange: function onChange(selected) {
            if (item.multiSelect === false) {
              if (item._groupKey_ !== '_super_') {
                setActiveIndex(-1);
              }
              _this6.doItemFilter({ value: selected[0].value, text: selected[0].text, name: item.name });
            } else {
              setSelect(_defineProperty({}, item.name, selected));
            }
          },
          props: this.props
        }),
        this.renderSelectFooter(item)
      );
    }
  }, {
    key: 'renderSuper',
    value: function renderSuper(group) {
      var _this7 = this;

      var _props7 = this.props,
          setActiveIndex = _props7.setActiveIndex,
          getSelect = _props7.getSelect;
      var children = group.children;

      if (!children || !children.length) {
        return null;
      }
      return _react2.default.createElement(
        _Popup2.default,
        {
          stopBodyScrolling: false,
          content: _react2.default.createElement(
            'div',
            { className: _Context2.default.prefixClass('filter-popup-container'), style: { height: window.innerHeight - 84 } },
            group.children.map(function (item) {
              if (!item.name) {
                return null;
              }
              var View = item.renderView;
              if (View && typeof View === 'function') {
                return _this7.renderCustomView(item);
              }
              if (item.type === 'switch') {
                var currentSelectedData = getSelect()[item.name];
                var isOn = !!(currentSelectedData && currentSelectedData.length);
                return _react2.default.createElement(
                  'div',
                  { className: 'switch-wrapper', key: item.name },
                  _react2.default.createElement(
                    'label',
                    { className: 'label' },
                    !isOn ? item.title : currentSelectedData[0].text
                  ),
                  _react2.default.createElement(_Switch2.default, { on: isOn, onChange: function onChange() {
                      _this7.handleSwitchChange(item, !isOn);
                    } })
                );
              }
              item.tip = item.title;
              if (item.items.length > 8) {
                item.needCollapse = true;
              }
              return _react2.default.createElement(
                'div',
                { key: item.name },
                _this7.renderPanel(item)
              );
            }),
            _react2.default.createElement(
              'div',
              { className: _Context2.default.prefixClass('filter-popup-footer') },
              _react2.default.createElement(
                _Button2.default.Group,
                null,
                _react2.default.createElement(
                  _Button2.default,
                  { type: 'secondary', display: 'inline', onClick: function onClick() {
                      _this7.resetSuper();
                    } },
                  '\u91CD \u7F6E'
                ),
                _react2.default.createElement(
                  _Button2.default,
                  { type: 'primary', display: 'inline', onClick: function onClick() {
                      _this7.confirm();
                    } },
                  '\u786E \u5B9A'
                )
              )
            ),
            this.renderPicker()
          ),
          animationType: 'slide-left',
          onMaskClick: function onMaskClick() {
            setActiveIndex(-1);
          },
          visible: true
        },
        null
      );
    }
  }, {
    key: 'renderPanel',
    value: function renderPanel(group) {
      if (!group) {
        return null;
      }
      switch (group.type) {
        case 'order':
          return this.renderOrder(group);
        case 'select':
          return this.renderSelect(group);
        case 'super':
          return this.renderSuper(group);
        default:
          if (group.renderView && typeof group.renderView === 'function') {
            return this.renderCustomView(group);
          }
          return null;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props8 = this.props,
          options = _props8.options,
          activeIndex = _props8.activeIndex;

      var group = options.groups[activeIndex];

      var _ref2 = group || {},
          maxHeight = _ref2.maxHeight;

      return _react2.default.createElement(
        'div',
        { className: _Context2.default.prefixClass('filter-panel-wrapper'), style: { maxHeight: maxHeight || 2000 } },
        this.renderPanel(group)
      );
    }
  }]);

  return FilterPanel;
}(_react2.default.Component);

FilterPanel.displayName = 'FilterPanel';
FilterPanel.propTypes = {};
FilterPanel.defaultProps = {};
exports.default = FilterPanel;
module.exports = exports['default'];