'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * FormGroup Component Style for SaltUI
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author xuhao.wxh
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2018-2019, SaltUI Team, Alinw.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var changeEvents = ['onChange', 'onSelect', 'onOk', 'onConfirm'];

// 缓存每一个组件的change事件名称，props变化时需要刷新
var changeEventsKeyCache = {};

var noop = function noop() {};

var FormGroup = function (_React$Component) {
  _inherits(FormGroup, _React$Component);

  function FormGroup(props) {
    _classCallCheck(this, FormGroup);

    // 初始化表单组数据
    var _this = _possibleConstructorReturn(this, (FormGroup.__proto__ || Object.getPrototypeOf(FormGroup)).call(this, props));

    var data = _this.props.data;

    if (Object.prototype.toString.call(data) !== '[object Array]') {
      console.error('Component FormGroup prop data must be a Array');
      data = [];
    }
    _this.state = {
      data: data
    };

    _this.cloneForm = _this.cloneForm.bind(_this);
    _this.add = _this.add.bind(_this);
    _this.delete = _this.delete.bind(_this);
    _this.setValue = _this.setValue.bind(_this);
    return _this;
  }

  /**
   * 触发onChange回调
   * @param {*} type change类型
   * @param {*} value 变动内容
   * @param {*} data 表单组全部值
   *
   * value格式：
   * 新增或删除操作：只传变动的组的序号
   * {
   *    index: 1,
   * }
   * 编辑操作：传变动的组的序号，field name，和变动值
   * {
   *    index: 1,
   *    name: 'selectField',
   *    value: 'xxx'
   * }
   */


  _createClass(FormGroup, [{
    key: 'onChange',
    value: function onChange(type, value, data) {
      this.props.onChange(type, value, data);
    }
  }, {
    key: 'setValue',
    value: function setValue(itemIndex, name, value) {
      var data = this.state.data;

      data[itemIndex][name] = value;
      this.setState({
        data: data
      });
      this.onChange('modify', {
        index: itemIndex,
        name: name,
        value: value
      }, data);
    }

    /**
     * 根据数组中的数据，和传入的fields，复制整个表单
     * @param {*} fields 传入的fields，即children
     *
     * formSlice：根据一行数据复制出来的表单切片
     * 复制field的时候，需要：
     * 1. 劫持change事件
     * 2. 覆盖value值
     */

  }, {
    key: 'cloneForm',
    value: function cloneForm(fields) {
      var _this2 = this;

      var title = this.props.title;
      var data = this.state.data;


      return data.map(function (item, itemIndex) {
        // 循环数据
        var formSlice = _react2.default.Children.map(fields, function (field) {
          var name = field.props.name;
          if (!name) {
            // 如果非field,直接赋值
            return _react2.default.cloneElement(field);
          }
          var propsToMerge = {
            value: item[name]
          };

          // 根据name获取组件的change事件名称
          var changeEventKey = changeEventsKeyCache[name];
          if (changeEventKey === null || Boolean(changeEventKey)) {
            // 值为null 代表搜索过但是没有搜索到change key，所以设置了null
            // Boolean(changeEventKey) 为true代表，搜索到了change key
          } else {
            // 没有搜索过key，在changeEvents里搜索一次
            var key = Object.keys(field.props).find(function (propKey) {
              return changeEvents.find(function (event) {
                return event === propKey;
              });
            });
            if (key) {
              changeEventKey = key;
              changeEventsKeyCache[name] = key; // 缓存找到的change key
            } else {
              changeEventsKeyCache[name] = null; // 设置null代表搜索过但是没有搜索到
            }
          }

          // 代理组件的change事件，merge进propsToMerge
          if (changeEventKey) {
            propsToMerge[changeEventKey] = function (value) {
              _this2.setValue(itemIndex, name, value);
              field.props[changeEventKey](value, itemIndex);
            };
          }
          return _react2.default.cloneElement(field, propsToMerge);
        });

        var titleComponent = null;
        if (typeof title === 'string') {
          titleComponent = _react2.default.createElement(
            'span',
            null,
            title
          );
        } else if (typeof title === 'function') {
          titleComponent = _react2.default.createElement(
            'span',
            null,
            title(itemIndex + 1)
          );
        }

        return _react2.default.createElement(
          'div',
          { className: 't-form-group-slice', key: itemIndex },
          _react2.default.createElement(
            'div',
            { className: 't-form-group-slice-title' },
            titleComponent,
            _react2.default.createElement(
              'a',
              { className: 't-form-group-slice-delete', onClick: _this2.delete.bind(_this2, itemIndex) },
              '\u5220\u9664'
            )
          ),
          _react2.default.createElement(
            'div',
            null,
            formSlice
          )
        );
      });
    }
  }, {
    key: 'add',
    value: function add() {
      var computed = this.state.data.concat({});
      this.setState({
        data: computed
      });

      this.onChange('add', {
        index: computed.length - 1
      }, computed);
    }
  }, {
    key: 'delete',
    value: function _delete(index, e) {
      e && e.preventDefault();
      var data = this.state.data;

      if (data.length === 1) {
        // 当只剩最后一个的时候
        var computed = [{}];
        this.setState({
          data: computed
        });

        this.onChange('delete', {
          index: 0
        }, computed);
      } else {
        data.splice(index, 1); // 删除index位
        this.setState({
          data: data
        });

        this.onChange('delete', {
          index: 0
        }, data);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('t-form-group', this.props.className) },
        this.cloneForm(this.props.children),
        _react2.default.createElement(
          'div',
          { className: 't-form-group-add', onClick: this.add },
          '\u65B0\u589E\u4E00\u6761'
        )
      );
    }
  }]);

  return FormGroup;
}(_react2.default.Component);

FormGroup.propTypes = {
  onChange: _propTypes2.default.func,
  data: _propTypes2.default.array,
  children: _propTypes2.default.node,
  title: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.func]),
  className: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.array])
};
FormGroup.defaultProps = {
  onChange: noop,
  data: []
};
exports.default = FormGroup;
module.exports = exports['default'];