'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _Context = require('../Context');

var _Style = require('../Style');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Group.List Component for SaltUI
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author gnosaij
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2018-2019, SaltUI Team, Alinw.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var isEmptyValue = function isEmptyValue(v) {
  return v === null || v === undefined || v === '';
};

var style = (0, _Style.createStyleContext)((0, _Context.prefixClass)('group-list'));

var List = function (_React$Component) {
  _inherits(List, _React$Component);

  function List(props) {
    _classCallCheck(this, List);

    var _this = _possibleConstructorReturn(this, (List.__proto__ || Object.getPrototypeOf(List)).call(this, props));

    var t = _this;
    t._lineIndentClassName = [];
    t._itemIndentClassName = [];
    if (props.lineIndent) {
      t.addIndent('Line');
    }
    if (props.itemIndent) {
      t.addIndent('Item');
    }
    return _this;
  }

  // 由props属性转换成css样式规则 并插入到页面


  _createClass(List, [{
    key: 'addIndent',
    value: function addIndent(type) {
      var t = this;
      var indentArray = [].concat(t.props[type.toLowerCase() + 'Indent']);

      var className = [];
      className.push(t['make' + type + 'IndentClassName']('left', (0, _Style.unitize)(indentArray[0])));
      className.push(t['make' + type + 'IndentClassName']('right', (0, _Style.unitize)(indentArray[1])));

      t['_' + type + 'IndentClassName'] = className.join(' ');
    }
    /* eslint-disable class-methods-use-this */
    /**
       * 生成间隔线缩进对应的`classClass`值和`CSS`样式
       * @param side {String} Left|Right
       * @param value {String} `CSS`样式的长度值
       * @returns {String} 生成的`className`字符串
       */

  }, {
    key: 'makeLineIndentClassName',
    value: function makeLineIndentClassName(side, value) {
      if (!value) {
        return null;
      }
      var lowerSide = side.toLowerCase();
      var indent = side + '-' + value;
      style.add('line-indent-' + indent, '\n            .' + (0, _Context.prefixClass)('group-list') + '.line-indent-' + indent + ' .' + (0, _Context.prefixClass)('group-list-item') + ':after{\n                ' + lowerSide + ': ' + value + '\n            }\n        ');
      return 'line-indent-' + indent;
    }

    /**
       * 生成Item缩进对应的`classClass`值和`CSS`样式
       * @param side {String} Left|Right
       * @param value {String} `CSS`样式的长度值
       * @returns {String} 生成的`className`字符串
       */

  }, {
    key: 'makeItemIndentClassName',
    value: function makeItemIndentClassName(side, value) {
      if (!value) {
        return null;
      }
      var lowerSide = side.toLowerCase();
      var indent = side + '-' + value;
      style.add('item-indent-' + indent, '\n            .' + (0, _Context.prefixClass)('group-list') + '.item-indent-' + indent + ' .' + (0, _Context.prefixClass)('group-list-item') + '{\n                padding-' + lowerSide + ': ' + value + '\n            }\n        ');
      return 'item-indent-' + indent;
    }
    /* eslint-enable class-methods-use-this */

  }, {
    key: 'render',
    value: function render() {
      var _classnames;

      var t = this;
      return _react2.default.createElement(
        'div',
        { className: (0, _classnames3.default)((0, _Context.prefixClass)('group-list'), (_classnames = {}, _defineProperty(_classnames, t.props.className, !!t.props.className), _defineProperty(_classnames, t._LineIndentClassName, !!t._LineIndentClassName), _defineProperty(_classnames, t._ItemIndentClassName, !!t._ItemIndentClassName), _defineProperty(_classnames, (0, _Context.prefixClass)('BT1'), !t.props.borderTopNone), _classnames))
        },
        _react2.default.Children.map(t.props.children, function (Item) {
          return (
            // 需要过滤掉空值的item
            !isEmptyValue(Item) ? _react2.default.createElement(
              'div',
              { className: (0, _Context.prefixClass)('group-list-item') },
              Item
            ) : null
          );
        })
      );
    }
  }]);

  return List;
}(_react2.default.Component);

List.displayName = 'Group.List';

var indentType = _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string, _propTypes2.default.array]);

List.propTypes = {
  className: _propTypes2.default.string,
  lineIndent: indentType,
  itemIndent: indentType,
  borderTopNone: _propTypes2.default.bool
};

List.defaultProps = {
  borderTopNone: false,
  className: undefined,
  lineIndent: undefined,
  itemIndent: undefined
};

exports.default = List;
module.exports = exports['default'];