'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Context = require('../Context');

var _Context2 = _interopRequireDefault(_Context);

var _NumberItem = require('./NumberItem');

var _NumberItem2 = _interopRequireDefault(_NumberItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * NumberInfo Component for SaltUI
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author shuaige
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2018-2019, SaltUI Team.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var NumberInfo = function (_React$Component) {
  _inherits(NumberInfo, _React$Component);

  function NumberInfo() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, NumberInfo);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = NumberInfo.__proto__ || Object.getPrototypeOf(NumberInfo)).call.apply(_ref, [this].concat(args))), _this), _this.handleClick = function () {
      if (_this.props.onClick) {
        _this.props.onClick();
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(NumberInfo, [{
    key: 'renderNumber',
    value: function renderNumber(data) {
      var _data$props = data.props,
          positiveColor = _data$props.positiveColor,
          negativeColor = _data$props.negativeColor,
          number = _data$props.number;

      var num = (0, _NumberItem.formatNumber)(data.props);
      var unit = (0, _NumberItem.formatUnit)(data.props);
      return _react2.default.createElement(
        'span',
        { style: {
            color: number > 0 ? positiveColor : number < 0 ? negativeColor : ''
          }
        },
        _react2.default.createElement(
          'span',
          null,
          num
        ),
        unit ? _react2.default.createElement(
          'span',
          { className: _Context2.default.prefixClass('number-info-unit') },
          unit
        ) : null
      );
    }
  }, {
    key: 'renderSequence',
    value: function renderSequence(datas) {
      return datas.map(function (data, i) {
        return _react2.default.createElement(
          'span',
          { key: i },
          i ? ', ' : '',
          data
        );
      });
    }
  }, {
    key: 'renderData',
    value: function renderData() {
      var _this2 = this;

      var children = this.props.children;

      var primary = [];
      var secondary = [];
      _react2.default.Children.forEach(children, function (child) {
        if (child.type !== _NumberItem2.default) {
          console.warn('Only <NumberItem> components are allowed inside <NumberInfo>.');
          return;
        }
        (child.props.secondary ? secondary : primary).push(_this2.renderNumber(child));
      });
      return _react2.default.createElement(
        'div',
        { className: _Context2.default.prefixClass('number-info-number') },
        this.renderSequence(primary),
        secondary.length ? _react2.default.createElement(
          'span',
          null,
          ' (',
          this.renderSequence(secondary),
          ')'
        ) : null
      );
    }
  }, {
    key: 'renderLabel',
    value: function renderLabel() {
      var label = this.props.label;

      return label ? _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)(_Context2.default.prefixClass('number-info-label')) },
        label
      ) : null;
    }
  }, {
    key: 'render',
    value: function render() {
      var t = this;
      var _t$props = t.props,
          className = _t$props.className,
          layout = _t$props.layout;

      return layout === 'h' ? _react2.default.createElement(
        'div',
        {
          onClick: this.handleClick,
          className: (0, _classnames2.default)(className, _Context2.default.prefixClass('number-info'), _Context2.default.prefixClass('number-info-h'))
        },
        this.renderLabel(),
        this.renderData()
      ) : _react2.default.createElement(
        'div',
        {
          onClick: this.handleClick,
          className: (0, _classnames2.default)(className, _Context2.default.prefixClass('number-info'))
        },
        this.renderData(),
        this.renderLabel()
      );
    }
  }]);

  return NumberInfo;
}(_react2.default.Component);

exports.default = NumberInfo;


NumberInfo.defaultProps = {
  className: '',
  label: '',
  layout: 'v',
  onClick: function onClick() {},
  children: undefined
};

NumberInfo.propTypes = {
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  label: _propTypes2.default.string,
  layout: _propTypes2.default.oneOf(['v', 'h']),
  onClick: _propTypes2.default.func
};

NumberInfo.displayName = 'NumberInfo';

NumberInfo.NumberItem = _NumberItem2.default;
NumberInfo.Item = _NumberItem2.default;
NumberInfo.format = _NumberItem2.default.format;
module.exports = exports['default'];