'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * NumberInfo Component for SaltUI
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * @author shuaige
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * Copyright 2018-2019, SaltUI Team.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          */

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function formatNumber(params) {
  var number = params.number,
      digits = params.digits,
      groupDigits = params.groupDigits,
      spliter = params.spliter,
      max = params.max,
      showSign = params.showSign;

  var n = Math.min(Math.abs(number), max || Infinity);
  if (!n) {
    n = 0;
  }
  var str = digits === undefined ? '' + n : n.toFixed(digits);
  if (groupDigits >= 1 && spliter) {
    var _str$split = str.split('.'),
        _str$split2 = _slicedToArray(_str$split, 2),
        int = _str$split2[0],
        dec = _str$split2[1];

    str = '';
    while (int.length > groupDigits) {
      str = '' + spliter + int.substr(-groupDigits) + str;
      int = int.substr(0, int.length - groupDigits);
    }
    str = '' + int + str;
    if (dec) {
      str = str + '.' + dec;
    }
  }
  if (showSign !== false && number < 0) {
    str = '-' + str;
  } else if (showSign === true && number > 0) {
    str = '+' + str;
  }
  if (max && Math.abs(number) > max) {
    str = str + '+';
  }
  return str;
}

function formatUnit(params) {
  var unit = params.unit;

  return unit ? /^[a-zA-Z\u4E00-\u9FA5\uF900-\uFA2D]/.test(unit) ? ' ' + unit : unit : '';
}

function format(number, params) {
  return '' + formatNumber(_extends({}, NumberItem.defaultProps, params || {}, { number: number })) + formatUnit(params);
}

var NumberItem = function (_React$Component) {
  _inherits(NumberItem, _React$Component);

  function NumberItem() {
    _classCallCheck(this, NumberItem);

    return _possibleConstructorReturn(this, (NumberItem.__proto__ || Object.getPrototypeOf(NumberItem)).apply(this, arguments));
  }

  _createClass(NumberItem, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'span',
        { className: this.props.className },
        '' + formatNumber(this.props) + formatUnit(this.props)
      );
    }
  }]);

  return NumberItem;
}(_react2.default.Component);

exports.default = NumberItem;


NumberItem.defaultProps = {
  number: 0,
  digits: undefined,
  groupDigits: 3,
  spliter: ',',
  max: 0,
  unit: '',
  showSign: undefined,
  secondary: false
};

NumberItem.propTypes = {
  number: _propTypes2.default.number,
  digits: _propTypes2.default.number,
  groupDigits: _propTypes2.default.number,
  spliter: _propTypes2.default.string,
  max: _propTypes2.default.number,
  showSign: _propTypes2.default.bool,
  positiveColor: _propTypes2.default.string,
  negativeColor: _propTypes2.default.string,
  unit: _propTypes2.default.string,
  secondary: _propTypes2.default.bool
};

NumberItem.displayName = 'NumberItem';
NumberItem.formatNumber = formatNumber;
NumberItem.formatUnit = formatUnit;
NumberItem.format = format;
module.exports = exports['default'];