'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _MinusRound = require('salt-icon/lib/MinusRound');

var _MinusRound2 = _interopRequireDefault(_MinusRound);

var _FileEmpty = require('salt-icon/lib/FileEmpty');

var _FileEmpty2 = _interopRequireDefault(_FileEmpty);

var _FileExcel = require('salt-icon/lib/FileExcel');

var _FileExcel2 = _interopRequireDefault(_FileExcel);

var _FileMusic = require('salt-icon/lib/FileMusic');

var _FileMusic2 = _interopRequireDefault(_FileMusic);

var _FilePdf = require('salt-icon/lib/FilePdf');

var _FilePdf2 = _interopRequireDefault(_FilePdf);

var _FilePicture = require('salt-icon/lib/FilePicture');

var _FilePicture2 = _interopRequireDefault(_FilePicture);

var _FilePowerpoint = require('salt-icon/lib/FilePowerpoint');

var _FilePowerpoint2 = _interopRequireDefault(_FilePowerpoint);

var _FileText = require('salt-icon/lib/FileText');

var _FileText2 = _interopRequireDefault(_FileText);

var _FileVideo = require('salt-icon/lib/FileVideo');

var _FileVideo2 = _interopRequireDefault(_FileVideo);

var _FileWord = require('salt-icon/lib/FileWord');

var _FileWord2 = _interopRequireDefault(_FileWord);

var _FileXml = require('salt-icon/lib/FileXml');

var _FileXml2 = _interopRequireDefault(_FileXml);

var _FileZip = require('salt-icon/lib/FileZip');

var _FileZip2 = _interopRequireDefault(_FileZip);

var _Refresh = require('salt-icon/lib/Refresh');

var _Refresh2 = _interopRequireDefault(_Refresh);

var _uploadcore = require('uploadcore');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Circle = require('./Circle');

var _Circle2 = _interopRequireDefault(_Circle);

var _Context = require('../Context');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var IconMap = {
  empty: _FileEmpty2.default,
  excel: _FileExcel2.default,
  music: _FileMusic2.default,
  pdf: _FilePdf2.default,
  picture: _FilePicture2.default,
  powerpoint: _FilePowerpoint2.default,
  text: _FileText2.default,
  video: _FileVideo2.default,
  word: _FileWord2.default,
  xml: _FileXml2.default,
  zip: _FileZip2.default
};

var imgExts = ['jpg', 'jpeg', 'gif', 'png', 'bmp', 'svg', 'tiff', 'tif', 'ico', 'jpe', 'svgz', 'pct', 'psp', 'ai', 'psd', 'raw', 'webp'];

var audioExts = ['aac', 'aif', 'flac', 'iff', 'm4a', 'm4b', 'mid', 'midi', 'mp3', 'mpa', 'mpc', 'oga', 'ogg', 'ra', 'ram', 'snd', 'wav', 'wma'];

var videoExts = ['avi', 'divx', 'flv', 'm4v', 'mkv', 'mov', 'mp4', 'mpeg', 'mpg', 'ogm', 'ogv', 'ogx', 'rm', 'rmvb', 'smil', 'webm', 'wmv', 'xvid'];

var codeExts = ['js', 'css', 'java', 'php', 'html', 'xml', 'json'];

var compressExts = ['zip', 'rar', '7z'];

var excelExts = ['xls', 'xlsx'];

var docExts = ['doc', 'docx'];

var pptExts = ['ppt', 'pptx', 'key'];

var txtExts = ['txt', 'text'];

var PhotoFieldFileItem = function (_React$Component) {
  _inherits(PhotoFieldFileItem, _React$Component);

  function PhotoFieldFileItem(props) {
    _classCallCheck(this, PhotoFieldFileItem);

    var _this = _possibleConstructorReturn(this, (PhotoFieldFileItem.__proto__ || Object.getPrototypeOf(PhotoFieldFileItem)).call(this, props));

    _this.state = {
      loaded: false
    };
    return _this;
  }

  _createClass(PhotoFieldFileItem, [{
    key: 'getDom',
    value: function getDom() {
      return this.root;
    }
  }, {
    key: 'getTypeIcon',
    value: function getTypeIcon() {
      var ext = this.props.ext || '';
      var isImage = function isImage(extName) {
        return imgExts.indexOf(extName) !== -1;
      };
      var isAudios = function isAudios(extName) {
        return audioExts.indexOf(extName) !== -1;
      };
      var isVideo = function isVideo(extName) {
        return videoExts.indexOf(extName) !== -1;
      };
      var isCode = function isCode(extName) {
        return codeExts.indexOf(extName) !== -1;
      };
      var isZip = function isZip(extName) {
        return compressExts.indexOf(extName) !== -1;
      };
      var isPdf = function isPdf(extName) {
        return extName === 'pdf';
      };
      var isExcel = function isExcel(extName) {
        return excelExts.indexOf(extName) !== -1;
      };
      var isPPT = function isPPT(extName) {
        return pptExts.indexOf(extName) !== -1;
      };
      var isWord = function isWord(extName) {
        return docExts.indexOf(extName) !== -1;
      };
      var isText = function isText(extName) {
        return txtExts.indexOf(extName) !== -1;
      };

      ext = ext.toLowerCase();

      switch (true) {
        case isImage(ext):
          return IconMap.picture;
        case isAudios(ext):
          return IconMap.music;
        case isVideo(ext):
          return IconMap.video;
        case isCode(ext):
          return IconMap.xml;
        case isZip(ext):
          return IconMap.zip;
        case isPdf(ext):
          return IconMap.pdf;
        case isExcel(ext):
          return IconMap.excel;
        case isPPT(ext):
          return IconMap.powerpoint;
        case isWord(ext):
          return IconMap.word;
        case isText(ext):
          return IconMap.text;
        default:
          return IconMap.empty;
      }
    }
  }, {
    key: 'handlePreview',
    value: function handlePreview() {
      this.props.onPreviewImage(this.props.index);
    }
  }, {
    key: 'handleDelete',
    value: function handleDelete(e) {
      e.stopPropagation();
      var _props = this.props,
          onDeleteImage = _props.onDeleteImage,
          file = _props.file;

      if (file) {
        file.cancel();
      } else {
        onDeleteImage(this.props.index);
      }
    }
  }, {
    key: 'renderProgressIcon',
    value: function renderProgressIcon() {
      var file = this.props.file;

      if (file.status === _uploadcore.Status.PROGRESS) {
        return _react2.default.createElement(_Circle2.default, {
          className: (0, _Context.prefixClass)('photo-progress-icon'),
          percent: file.progress.percentage
        });
      }
      if (file.status === _uploadcore.Status.ERROR) {
        return _react2.default.createElement(_Refresh2.default, {
          onClick: function onClick() {
            file.pending();
          },
          className: (0, _Context.prefixClass)('photo-file-item-type-icon')
        });
      }
      return null;
    }
  }, {
    key: 'renderIcon',
    value: function renderIcon() {
      var file = this.props.file;

      if (file) {
        return this.renderProgressIcon();
      }
      return this.renderTypeIcon();
    }
  }, {
    key: 'renderTypeIcon',
    value: function renderTypeIcon() {
      var TypeIcon = this.getTypeIcon();
      return _react2.default.createElement(TypeIcon, { className: (0, _Context.prefixClass)('photo-file-item-type-icon') });
    }
  }, {
    key: 'renderFileName',
    value: function renderFileName() {
      var _props2 = this.props,
          name = _props2.name,
          file = _props2.file;

      return _react2.default.createElement(
        'span',
        { className: (0, _Context.prefixClass)('photo-file-item-name') },
        file ? file.name : name
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var t = this;
      var file = this.props.file;

      return _react2.default.createElement(
        'div',
        {
          className: (0, _classnames2.default)((0, _Context.prefixClass)('photo-file-item'), {
            'is-error': file ? file.status === _uploadcore.Status.ERROR : false,
            'is-progress': file ? file.status === _uploadcore.Status.PROGRESS : false
          }),
          ref: function ref(c) {
            _this2.root = c;
          },
          onClick: function onClick() {
            _this2.handlePreview();
          }
        },
        t.renderIcon(),
        t.renderFileName(),
        !t.props.readOnly && _react2.default.createElement(_MinusRound2.default, { className: (0, _Context.prefixClass)('photo-file-item-delete-icon'), onClick: function onClick(e) {
            _this2.handleDelete(e);
          } })
      );
    }
  }]);

  return PhotoFieldFileItem;
}(_react2.default.Component);

PhotoFieldFileItem.defaultProps = {
  readOnly: false,
  index: undefined,
  onPreviewImage: undefined,
  onDeleteImage: undefined,
  ext: '',
  name: '',
  file: undefined
};

PhotoFieldFileItem.propTypes = {
  index: _propTypes2.default.number,
  readOnly: _propTypes2.default.bool,
  onPreviewImage: _propTypes2.default.func,
  onDeleteImage: _propTypes2.default.func,
  ext: _propTypes2.default.string,
  name: _propTypes2.default.string,
  file: _propTypes2.default.object
};

exports.default = PhotoFieldFileItem;
module.exports = exports['default'];