'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Popup = require('../Popup');

var _Popup2 = _interopRequireDefault(_Popup);

var _SearchPanel = require('./SearchPanel');

var _SearchPanel2 = _interopRequireDefault(_SearchPanel);

var _i18n = require('./i18n');

var _i18n2 = _interopRequireDefault(_i18n);

var _utils = require('./utils');

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Picker = function (_React$Component) {
  _inherits(Picker, _React$Component);

  function Picker(props) {
    _classCallCheck(this, Picker);

    var _this = _possibleConstructorReturn(this, (Picker.__proto__ || Object.getPrototypeOf(Picker)).call(this, props));

    _this.listener = _this.handleHidePopup.bind(_this);
    return _this;
  }

  _createClass(Picker, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (prevProps.visible === false && this.props.visible === true) {
        this.historyStamp = 'Picker.index_' + Date.now();
        window.history.pushState({
          PickerField: this.historyStamp
        }, '', _utils2.default.addUrlParam('PICKER', Date.now()));

        window.addEventListener('popstate', this.listener, false);
      } else if (prevProps.visible === true && this.props.visible === false) {
        this.hide();
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('popstate', this.listener, false);
    }
  }, {
    key: 'handleHidePopup',
    value: function handleHidePopup(e) {
      var state = e.state;

      if (!state || !state.PickerField || state.PickerField !== this.historyStamp) {
        this.hide(true);
      }
    }
  }, {
    key: 'hide',
    value: function hide(fromEvent) {
      if (this.historyStamp) {
        var t = this;
        window.removeEventListener('popstate', t.listener, false);
        if (!fromEvent) {
          window.history.go(-1);
        }
        this.historyStamp = '';
        t.props.onVisibleChange(false);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          visible = _props.visible,
          className = _props.className,
          panelProps = _objectWithoutProperties(_props, ['visible', 'className']);

      var locale = panelProps.locale;

      var fixProps = {
        confirmText: panelProps.confirmText || _i18n2.default[locale].confirmText,
        searchPlaceholder: panelProps.searchPlaceholder || _i18n2.default[locale].searchPlaceholder,
        searchNotFoundContent: panelProps.searchNotFoundContent || _i18n2.default[locale].noData
      };
      return _react2.default.createElement(_Popup2.default, {
        className: className,
        animationType: 'slide-left',
        stopBodyScrolling: false,
        visible: visible,
        content: _react2.default.createElement(_SearchPanel2.default, _extends({}, panelProps, fixProps))
      });
    }
  }]);

  return Picker;
}(_react2.default.Component);

Picker.defaultProps = {
  visible: false,
  value: [],
  className: '',
  historyStamp: undefined,
  confirmText: undefined,
  onVisibleChange: function onVisibleChange() {},
  onConfirm: function onConfirm() {},
  options: undefined,
  fetchUrl: '',
  fetchMethod: 'GET',
  fetchDataOnOpen: true,
  dataType: 'jsonp',
  beforeFetch: function beforeFetch(obj) {
    return obj;
  },
  fitResponse: function fitResponse(response) {
    return {
      content: response.content || response,
      success: response.success === undefined ? true : response.success
    };
  },
  afterFetch: function afterFetch(obj) {
    return obj;
  },
  locale: 'zh-cn',
  searchNotFoundContent: undefined,
  resultFormatter: undefined,
  formatter: function formatter(value) {
    if (value) {
      if (value.text !== undefined) {
        return value.text;
      }
      if (value.value !== undefined) {
        return value.value;
      }
    }
    return '';
  },
  phonetic: function phonetic(value) {
    return value.phonetic || [];
  },
  multiple: false,
  grouping: false,
  groupingIndicator: false,
  showSearch: true,
  searchDelay: 100,
  searchPlaceholder: undefined,
  customRender: null
};

Picker.propTypes = {
  visible: _propTypes2.default.bool,
  onVisibleChange: _propTypes2.default.func,
  locale: _propTypes2.default.string,
  fetchUrl: _propTypes2.default.string,
  fetchMethod: _propTypes2.default.string,
  options: _propTypes2.default.array,
  fetchDataOnOpen: _propTypes2.default.bool,
  dataType: _propTypes2.default.string,
  beforeFetch: _propTypes2.default.func,
  fitResponse: _propTypes2.default.func,
  afterFetch: _propTypes2.default.func,
  showSearch: _propTypes2.default.bool,
  searchDelay: _propTypes2.default.number,
  formatter: _propTypes2.default.func,
  phonetic: _propTypes2.default.func,
  multiple: _propTypes2.default.bool,
  grouping: _propTypes2.default.bool,
  groupingIndicator: _propTypes2.default.bool,
  resultFormatter: _propTypes2.default.func,
  value: _propTypes2.default.array,
  historyStamp: _propTypes2.default.string,
  searchNotFoundContent: _propTypes2.default.string,
  onConfirm: _propTypes2.default.func,
  confirmText: _propTypes2.default.string,
  searchPlaceholder: _propTypes2.default.string,
  customRender: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.object])
};

Picker.displayName = 'Picker';

exports.default = Picker;
module.exports = exports['default'];