'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Check = require('salt-icon/lib/Check');

var _Check2 = _interopRequireDefault(_Check);

var _CheckRound = require('salt-icon/lib/CheckRound');

var _CheckRound2 = _interopRequireDefault(_CheckRound);

var _lie = require('lie');

var _lie2 = _interopRequireDefault(_lie);

var _nattyFetch = require('natty-fetch');

var _nattyFetch2 = _interopRequireDefault(_nattyFetch);

var _Context = require('../Context');

var _Context2 = _interopRequireDefault(_Context);

var _ScrollView = require('../ScrollView');

var _ScrollView2 = _interopRequireDefault(_ScrollView);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _Popup = require('../Popup');

var _Popup2 = _interopRequireDefault(_Popup);

var _SearchBar = require('../SearchBar');

var _SearchBar2 = _interopRequireDefault(_SearchBar);

var _Tab = require('../Tab');

var _Tab2 = _interopRequireDefault(_Tab);

var _SearchResult = require('./SearchResult');

var _SearchResult2 = _interopRequireDefault(_SearchResult);

var _GroupingBar = require('./GroupingBar');

var _GroupingBar2 = _interopRequireDefault(_GroupingBar);

var _utils = require('./utils');

var _utils2 = _interopRequireDefault(_utils);

var _i18n = require('./i18n');

var _i18n2 = _interopRequireDefault(_i18n);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * PickerField Component for SaltUI
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author longyan
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2018-2019, SaltUI Team.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var SearchPanel = function (_React$Component) {
  _inherits(SearchPanel, _React$Component);

  _createClass(SearchPanel, null, [{
    key: 'getSearchTips',
    value: function getSearchTips() {
      return _react2.default.createElement('div', null);
    }
  }]);

  function SearchPanel(props) {
    _classCallCheck(this, SearchPanel);

    var _this = _possibleConstructorReturn(this, (SearchPanel.__proto__ || Object.getPrototypeOf(SearchPanel)).call(this, props));

    _initialiseProps.call(_this);

    var t = _this;
    var value = props.value,
        categories = props.categories;

    t.state = {
      value: value || [],
      results: [],
      searchMode: false,
      popupVisible: false,
      selectedResult: undefined
    };
    if (categories) {
      t.state.activeCategory = categories[0].value;
    }
    t.delaySearch = _utils2.default.debounce(t.search.bind(t), t.props.searchDelay);
    t.handleLeaveResultView = t.handleLeaveResultView.bind(t);
    t.groupEl = {};
    return _this;
  }

  _createClass(SearchPanel, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var t = this;
      if (t.props.fetchDataOnOpen) {
        t.fetchData();
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (!this.props.fetchUrl && this.props.options !== prevProps.options) {
        this.fetchData({ term: this.searchBar ? this.searchBar.getKeyword() : '' });
      }
    }
  }, {
    key: 'setData',
    value: function setData(fetchData) {
      var t = this;
      var state = {};
      if (t.props.grouping) {
        var groups = {};
        fetchData.sort(function (a, b) {
          var phoneticA = t.props.phonetic(a);
          var phoneticB = t.props.phonetic(b);
          var compare = 0;
          phoneticA.some(function (string, i) {
            if (!phoneticB[i] || string > phoneticB[i]) {
              compare = 1;
              return true;
            } else if (string < phoneticB[i]) {
              compare = -1;
              return true;
            }
            return false;
          });
          return compare;
        });
        fetchData.forEach(function (item) {
          var group = (t.props.phonetic(item)[0] || '#')[0].toUpperCase();
          if (group < 'A' || group > 'Z') {
            group = '#';
          }
          groups[group] = groups[group] || [];
          groups[group].push(item);
        });
        fetchData = Object.keys(groups).sort(function (a, b) {
          return _utils2.default.alphabet.indexOf(a) - _utils2.default.alphabet.indexOf(b);
        }).map(function (key) {
          return {
            title: key,
            items: groups[key]
          };
        });
      }
      state.results = fetchData;
      t.setState(state);
    }
  }, {
    key: 'fetchRemoteData',
    value: function fetchRemoteData() {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          term = _ref.term;

      var t = this;
      if (t.fetch) {
        t.fetch.abort();
      }
      if (t.props.fetchUrl) {
        t.fetch = _nattyFetch2.default.create({
          url: t.props.fetchUrl,
          method: t.props.fetchMethod,
          jsonp: t.props.dataType ? t.props.dataType === 'jsonp' : /\.jsonp/.test(t.props.fetchUrl),
          data: t.props.beforeFetch({ q: term }),
          fit: t.props.fitResponse,
          Promise: _lie2.default
        });
        t.fetch().then(function (data) {
          var fetchData = t.props.afterFetch(data);
          t.setData(fetchData);
        }).catch(function (e) {
          console.error(e); // eslint-disable-line no-console
        });
      }
    }
  }, {
    key: 'fetchLocalData',
    value: function fetchLocalData() {
      var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          term = _ref2.term;

      var t = this;
      var options = t.props.options || [];
      if (t.props.filterOption) {
        if (typeof t.props.filterOption === 'function') {
          var filteredData = term ? options.filter(function (item) {
            return t.props.filterOption(term, item);
          }) : options;
          t.setData(filteredData);
        } else {
          if (!t.searchIndex) {
            var processFunc = function processFunc(value) {
              var phonetic = t.props.phonetic(value);
              return [t.props.formatter(value, _utils2.default.FORMATTER_TYPES.OPTION_FORMATTER).toString().toLowerCase(), phonetic.join('').toLowerCase(), phonetic.map(function (str) {
                return str[0] || '';
              }).join('').toLowerCase()];
            };
            t.searchIndex = options.map(function (item) {
              return {
                indexes: processFunc(item),
                item: item
              };
            });
          }
          var _filteredData = term ? t.searchIndex.filter(function (entity) {
            return entity.indexes.some(function (indexText) {
              return indexText.indexOf(term.toLowerCase()) > -1;
            });
          }).map(function (entity) {
            return entity.item;
          }) : options;
          t.setData(_filteredData);
        }
      } else {
        t.setData(options);
      }
    }
  }, {
    key: 'fetchData',
    value: function fetchData() {
      var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          term = _ref3.term;

      var t = this;
      if (t.props.fetchUrl) {
        t.fetchRemoteData({ term: term });
      } else {
        t.fetchLocalData({ term: term });
      }
    }
  }, {
    key: 'search',
    value: function search(term) {
      var t = this;
      // t.fetchData({ term });

      if (t.props.fetchUrl || t.props.filterOption) {
        t.fetchData({ term: term });
      }
      t.props.onSearch(term);
    }
  }, {
    key: 'handleSearchChange',
    value: function handleSearchChange(term) {
      var t = this;
      t.delaySearch(term);
    }
  }, {
    key: 'handleSearchEnter',
    value: function handleSearchEnter() {
      var t = this;
      t.setState({
        searchMode: true
      });
    }
  }, {
    key: 'handleSearchLeave',
    value: function handleSearchLeave() {
      var t = this;
      t.setState({
        searchMode: false
      });
    }
  }, {
    key: 'handleConfirm',
    value: function handleConfirm() {
      this.props.onConfirm(this.state.value);
    }
  }, {
    key: 'handleEnterResultView',
    value: function handleEnterResultView() {
      var _this2 = this;

      this.setState({
        popupVisible: true
      }, function () {
        window.history.pushState({
          PickerField: 'SearchPanel.result'
        }, '', _utils2.default.addUrlParam('PICKER', Date.now()));

        window.addEventListener('popstate', _this2.handleLeaveResultView, false);
      });
    }
  }, {
    key: 'handleLeaveResultView',
    value: function handleLeaveResultView(e) {
      var state = e.state;

      if (state && state.PickerField === this.props.historyStamp) {
        window.removeEventListener('popstate', this.handleLeaveResultView, false);
        this.setState({
          popupVisible: false
        });
      }
    }
  }, {
    key: 'isItemChecked',
    value: function isItemChecked(item) {
      var t = this;
      var found = -1;
      t.state.value.forEach(function (v, i) {
        if (v.value === item.value) {
          found = i;
        }
      });
      return found > -1;
    }
  }, {
    key: 'selectGrouping',
    value: function selectGrouping(key) {
      var t = this;
      var element = t.groupEl[key];
      if (element) {
        element.scrollIntoView();
      }
    }
  }, {
    key: 'isEmpty',
    value: function isEmpty() {
      return this.state.value.length === 0;
    }
  }, {
    key: 'renderEmpty',
    value: function renderEmpty() {
      var t = this;
      return _react2.default.createElement(
        'div',
        { className: _Context2.default.prefixClass('picker-search-empty') },
        _react2.default.createElement(
          'div',
          { className: _Context2.default.prefixClass('picker-search-empty-inner') },
          t.props.searchNotFoundContent
        )
      );
    }
  }, {
    key: 'renderResults',
    value: function renderResults(results) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var t = this;
      var shouldShowInCategory = this.props.shouldShowInCategory;
      var category = options.category;

      return _react2.default.createElement(
        'div',
        { className: _Context2.default.prefixClass('picker-search-results') },
        t.props.grouping ? t.renderGroups(results, { category: category }) : (category ? results.filter(function (item) {
          return shouldShowInCategory(category, item);
        }) : results).map(function (item, index) {
          return t.renderResultItem(item, index);
        })
      );
    }
  }, {
    key: 'renderGroups',
    value: function renderGroups(groups) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var t = this;
      var category = options.category;
      var shouldShowInCategory = this.props.shouldShowInCategory;

      var newGroups = groups;
      if (category) {
        newGroups = groups.map(function (group) {
          return _extends({}, group, {
            items: group.items.filter(function (item) {
              return shouldShowInCategory(category, item);
            })
          });
        }).filter(function (group) {
          return group.items.length > 0;
        });
      }
      return newGroups.map(function (group) {
        return _react2.default.createElement(
          'div',
          {
            className: _Context2.default.prefixClass('picker-grouping'),
            key: group.title,
            ref: function ref(_ref4) {
              t.groupEl[group.title] = _ref4;
            }
          },
          _react2.default.createElement(
            'div',
            { className: _Context2.default.prefixClass('picker-grouping-title') },
            _react2.default.createElement(
              'p',
              { className: _Context2.default.prefixClass('picker-grouping-title-inner') },
              group.title
            )
          ),
          group.items.map(function (item, index) {
            return t.renderResultItem(item, index);
          })
        );
      });
    }
  }, {
    key: 'renderResultItem',
    value: function renderResultItem(item, index) {
      var t = this;

      var checked = t.isItemChecked(item);
      var iconHTML = void 0;
      if (t.props.multiple) {
        iconHTML = _react2.default.createElement(_CheckRound2.default, {
          className: (0, _classnames2.default)({
            'un-checked': !checked
          }),
          width: 20,
          height: 20
        });
      } else if (checked) {
        iconHTML = _react2.default.createElement(_Check2.default, {
          width: 14,
          height: 14
        });
      }

      return _react2.default.createElement(
        'div',
        {
          key: index,
          className: (0, _classnames2.default)(_Context2.default.prefixClass('picker-search-result-item'), _Context2.default.prefixClass('clear')),
          onClick: function onClick() {
            t.handleItemClick(item);
          }
        },
        _react2.default.createElement(
          'span',
          { className: (0, _classnames2.default)(_Context2.default.prefixClass('picker-search-result-item-icon'), t.props.grouping ? null : _Context2.default.prefixClass('picker-right-icon'))
          },
          iconHTML
        ),
        _react2.default.createElement(
          'span',
          { className: (0, _classnames2.default)(_Context2.default.prefixClass('picker-search-result-item-entry'), t.props.grouping ? null : _Context2.default.prefixClass('picker-right-icon')) },
          t.props.formatter(item, _utils2.default.FORMATTER_TYPES.OPTION_FORMATTER)
        )
      );
    }
  }, {
    key: 'renderResultCondition',
    value: function renderResultCondition() {
      var t = this;
      if (!t.state.results.length) {
        return t.renderEmpty();
      }
      return t.renderResults(t.state.results);
    }
  }, {
    key: 'renderGroupingBar',
    value: function renderGroupingBar() {
      var t = this;
      var activeCategory = this.state.activeCategory;
      var shouldShowInCategory = this.props.shouldShowInCategory;

      var groups = t.state.results;
      if (activeCategory) {
        groups = groups.map(function (group) {
          return _extends({}, group, {
            items: group.items.filter(function (item) {
              return shouldShowInCategory(activeCategory, item);
            })
          });
        }).filter(function (group) {
          return group.items.length > 0;
        });
      }
      var keys = groups.map(function (group) {
        return group.title;
      });
      return _react2.default.createElement(_GroupingBar2.default, {
        keys: keys,
        indicator: t.props.groupingIndicator,
        onSelect: t.selectGrouping.bind(t)
      });
    }
  }, {
    key: 'renderContent',
    value: function renderContent() {
      var customRender = this.props.customRender;

      return [customRender ? typeof customRender === 'function' ? customRender() : customRender : null, this.renderTab()];
    }
  }, {
    key: 'renderTab',
    value: function renderTab() {
      var _this3 = this;

      var categories = this.props.categories;

      if (categories) {
        return _react2.default.createElement(
          _Tab2.default,
          {
            key: 'tab1',
            wrapClassName: _Context2.default.prefixClass('picker-searchpanel-tab-wrap'),
            activeKey: this.state.activeCategory,
            onChange: function onChange(_ref5) {
              var activeKey = _ref5.activeKey;

              _this3.setState({
                activeCategory: activeKey
              });
            }
          },
          categories.map(function (item) {
            return _react2.default.createElement(
              _Tab2.default.Item,
              { key: item.value, title: item.text },
              _react2.default.createElement(
                _ScrollView2.default,
                null,
                _this3.renderResults(_this3.state.results, { category: item.value })
              )
            );
          })
        );
      }
      return _react2.default.createElement(
        _ScrollView2.default,
        null,
        this.renderResultCondition()
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      var t = this;
      var _t$props = t.props,
          showSearch = _t$props.showSearch,
          multiple = _t$props.multiple,
          locale = _t$props.locale;

      var pageSize = _utils2.default.getPageSize();
      var length = this.state.value.length;


      var resultProps = {
        value: [].concat(_toConsumableArray(this.state.value)),
        confirmText: this.props.confirmText,
        onConfirm: function onConfirm(value) {
          _this4.setState({
            value: value,
            popupVisible: false
          }, function () {
            window.history.go(-1);
          });
        },
        formatter: this.props.formatter,
        locale: this.props.locale
      };
      return _react2.default.createElement(
        'div',
        {
          className: (0, _classnames2.default)(_Context2.default.prefixClass('picker-searchpanel'), {
            multiple: multiple
          }),
          style: {
            width: pageSize.width + 'px',
            height: pageSize.height + 'px'
          }
        },
        _react2.default.createElement(
          'div',
          { className: _Context2.default.prefixClass('picker-searchpanel-inner') },
          showSearch ? _react2.default.createElement(
            'div',
            { className: _Context2.default.prefixClass('picker-searchpanel-header') },
            _react2.default.createElement(_SearchBar2.default, {
              ref: function ref(c) {
                t.searchBar = c;
              },
              locale: t.props.locale,
              placeholder: t.props.searchPlaceholder,
              className: _Context2.default.prefixClass('picker-searchpanel-search'),
              onChange: function onChange(val) {
                t.handleSearchChange(val);
              },
              onEnter: function onEnter() {
                t.handleSearchEnter();
              },
              onExit: function onExit() {
                t.handleSearchLeave();
              }
            })
          ) : null,
          _react2.default.createElement(
            'div',
            { className: _Context2.default.prefixClass('picker-searchpanel-content') },
            t.state.searchMode ? _react2.default.createElement(
              _ScrollView2.default,
              null,
              t.renderResultCondition()
            ) : t.renderContent(),
            t.props.grouping ? t.renderGroupingBar() : null
          ),
          multiple ? _react2.default.createElement(
            'div',
            { className: _Context2.default.prefixClass('picker-searchpanel-footer') },
            _react2.default.createElement(
              _Button2.default,
              {
                className: _Context2.default.prefixClass('picker-searchpanel-btn-ok'),
                size: 'small',
                display: 'inline',
                onClick: function onClick(e) {
                  t.handleConfirm(e);
                }
              },
              t.props.confirmText
            ),
            _react2.default.createElement(
              'div',
              {
                className: _Context2.default.prefixClass('picker-searchpanel-result-summary'),
                onClick: function onClick(e) {
                  t.handleEnterResultView(e);
                }
              },
              _react2.default.createElement(
                'a',
                { href: 'javascript:void(0);' },
                t.props.resultFormatter ? t.props.resultFormatter(this.state.value) : _i18n2.default[locale].selected(length)
              )
            )
          ) : null
        ),
        _react2.default.createElement(_Popup2.default, { stopBodyScrolling: false, content: _react2.default.createElement(_SearchResult2.default, resultProps), animationType: 'slide-left', visible: this.state.popupVisible })
      );
    }
  }]);

  return SearchPanel;
}(_react2.default.Component);

var _initialiseProps = function _initialiseProps() {
  var _this5 = this;

  this.handleItemClick = function (item) {
    var t = _this5;

    if (t.props.multiple) {
      var value = _this5.state.value;


      var found = -1;
      value.some(function (v, i) {
        if (v.value === item.value) {
          found = i;
          return true;
        }
        return false;
      });

      if (found > -1) {
        value.splice(found, 1);
        t.setState({
          value: value
        });
      } else {
        t.setState({
          value: [].concat(_toConsumableArray(value), [item])
        });
      }
    } else {
      t.setState({
        value: [item]
      }, function () {
        t.handleConfirm();
      });
    }
  };
};

SearchPanel.defaultProps = {
  onConfirm: function onConfirm() {},
  onSearch: function onSearch() {},

  showSearch: true,
  multiple: false,
  value: undefined,
  confirmText: undefined,
  fetchDataOnOpen: undefined,
  dataType: undefined,
  beforeFetch: undefined,
  fitResponse: undefined,
  afterFetch: undefined,
  searchDelay: undefined,
  searchPlaceholder: undefined,
  searchNotFoundContent: undefined,
  formatter: function formatter() {},

  phonetic: undefined,
  options: undefined,
  fetchUrl: undefined,
  fetchMethod: 'GET',
  grouping: undefined,
  locale: undefined,
  resultFormatter: undefined,
  historyStamp: undefined,
  filterOption: true,
  categories: undefined,
  shouldShowInCategory: function shouldShowInCategory() {
    return true;
  }
};

// http://facebook.github.io/react/docs/reusable-components.html
SearchPanel.propTypes = {
  value: _propTypes2.default.array,
  confirmText: _propTypes2.default.string,
  onConfirm: _propTypes2.default.func,
  onSearch: _propTypes2.default.func,
  options: _propTypes2.default.array,
  fetchUrl: _propTypes2.default.string,
  fetchMethod: _propTypes2.default.string,
  fetchDataOnOpen: _propTypes2.default.bool,
  dataType: _propTypes2.default.string,
  beforeFetch: _propTypes2.default.func,
  fitResponse: _propTypes2.default.func,
  afterFetch: _propTypes2.default.func,
  showSearch: _propTypes2.default.bool,
  searchDelay: _propTypes2.default.number,
  searchPlaceholder: _propTypes2.default.string,
  searchNotFoundContent: _propTypes2.default.string,
  formatter: _propTypes2.default.func,
  phonetic: _propTypes2.default.func,
  multiple: _propTypes2.default.bool,
  grouping: _propTypes2.default.bool,
  locale: _propTypes2.default.string,
  resultFormatter: _propTypes2.default.func,
  historyStamp: _propTypes2.default.string,
  filterOption: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.func]),
  categories: _propTypes2.default.array,
  shouldShowInCategory: _propTypes2.default.func
};

SearchPanel.displayName = 'SearchPanel';

exports.default = SearchPanel;
module.exports = exports['default'];