'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _Context = require('../Context');

var _Context2 = _interopRequireDefault(_Context);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Progress Component for SaltUI
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author shallker.wxd(dongnan)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2018-2019, SaltUI Team.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var Progress = function (_React$Component) {
  _inherits(Progress, _React$Component);

  function Progress() {
    _classCallCheck(this, Progress);

    return _possibleConstructorReturn(this, (Progress.__proto__ || Object.getPrototypeOf(Progress)).apply(this, arguments));
  }

  _createClass(Progress, [{
    key: 'render',
    value: function render() {
      var t = this;
      var percent = Math.round(parseFloat(t.props.percent));
      var percentWidth = percent + '%';

      var statusClass = '';

      if (t.props.status === 'normal') {
        statusClass = 'blue-bar';
      } else if (t.props.status === 'exception') {
        statusClass = 'red-bar';
      } else if (t.props.status === 'success') {
        statusClass = 'green-bar';
      } else {
        statusClass = 'blue-bar';
      }

      var showInfoClass = '';

      if (t.props.showInfo) {
        showInfoClass = 'with-label';
      } else {
        showInfoClass = 'without-label';
      }

      var labelText = '';

      if (percent < 0) {
        percent = 0;
        percentWidth = percent + '%';
      }

      if (percent > 100) {
        percent = 100;
        percentWidth = percent + '%';
      }

      if (percent >= 0 && percent < 100) {
        labelText = percent + '%';
      } else if (percent === 100) {
        labelText = '100%';
        statusClass = 'green-bar';
      } else {
        throw new Error('invalid percent');
      }

      var progressBarStyle = {
        height: t.props.strokeWidth + 'px'
      };

      var barCoreStyle = {
        width: percentWidth,
        height: t.props.strokeWidth + 'px'
      };
      if (t.props.color) {
        barCoreStyle.backgroundColor = t.props.color;
      }
      var barLabelStyle = {
        lineHeight: t.props.strokeWidth + 'px'
      };

      return _react2.default.createElement(
        'div',
        {
          className: (0, _classnames3.default)(_Context2.default.prefixClass('progress'), _defineProperty({}, t.props.className, !!t.props.className), showInfoClass)
        },
        _react2.default.createElement(
          'div',
          { className: (0, _classnames3.default)('progress-bar', statusClass), style: progressBarStyle },
          _react2.default.createElement('div', { className: 'bar-core', style: barCoreStyle })
        ),
        _react2.default.createElement(
          'div',
          { className: 'bar-label', style: barLabelStyle },
          labelText
        )
      );
    }
  }]);

  return Progress;
}(_react2.default.Component);

Progress.propTypes = {
  percent: _propTypes2.default.number,
  showInfo: _propTypes2.default.bool,
  status: _propTypes2.default.oneOf(['normal', 'exception', 'success']),
  strokeWidth: _propTypes2.default.number,
  color: _propTypes2.default.string
};
Progress.defaultProps = {
  // 进度条宽度
  strokeWidth: 8,

  // 当前进度百分比，0到100
  percent: 0,

  // 是否带有label信息
  showInfo: true,

  // bar的类型，'normal' 'exception' 'success'
  status: 'normal'
};
Progress.displayName = 'Progress';
exports.default = Progress;
module.exports = exports['default'];