'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactLifecyclesCompat = require('react-lifecycles-compat');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Loading = require('salt-icon/lib/Loading');

var _Loading2 = _interopRequireDefault(_Loading);

var _Context = require('../Context');

var _Context2 = _interopRequireDefault(_Context);

var _transitionEnd = require('./transitionEnd');

var _transitionEnd2 = _interopRequireDefault(_transitionEnd);

var _Drag = require('./Drag');

var _Drag2 = _interopRequireDefault(_Drag);

var _getOffset3 = require('./getOffset');

var _getOffset4 = _interopRequireDefault(_getOffset3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * RefeshControl Component for SaltUI
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author xiaohe.wp
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2018-2019, SaltUI Team.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var Status = {
  pending: 'pending',
  ready: 'ready',
  dragStart: 'dragStart',
  draging: 'draging',
  dragAnimate: 'dragAnimate',
  refreshing: 'refreshing',
  refreshAnimate: 'refreshAnimate'
};

function op(percent) {
  var percentNew = percent;
  percentNew = Number(percentNew.toFixed(2)) - 0.2;

  return percentNew > 0 ? percentNew : 0;
}

var RefreshControl = function (_React$Component) {
  _inherits(RefreshControl, _React$Component);

  function RefreshControl(props) {
    _classCallCheck(this, RefreshControl);

    var _this = _possibleConstructorReturn(this, (RefreshControl.__proto__ || Object.getPrototypeOf(RefreshControl)).call(this, props));

    _this.y = 0;
    _this.oldY = 0;
    _this.initTop = 0;
    _this.state = {};
    return _this;
  }

  _createClass(RefreshControl, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      this.bindDrag();
      this.initTopTimer = setTimeout(function () {
        if (_this2.trigger) {
          _this2.initTop = (0, _getOffset4.default)(_this2.trigger).top;
        }
      }, 200);
    }
  }, {
    key: 'getSnapshotBeforeUpdate',
    value: function getSnapshotBeforeUpdate(prevProps) {
      if (prevProps.refreshing !== this.props.refreshing) {
        this.onRefreshingChanged(this.props.refreshing);
      }
      return null;
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      if (this.y > 0) {
        this.triggerStyle(this.props.showRefreshing);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.drager) {
        this.drager.destory();
        this.drager = null;
      }
      if (this.initTopTimer) {
        clearTimeout(this.initTopTimer);
        this.initTopTimer = undefined;
      }
    }
  }, {
    key: 'onRefreshingChanged',
    value: function onRefreshingChanged(val) {
      if (!val) {
        (0, _transitionEnd2.default)(this.trigger, this.clearState.bind(this));
      } else {
        this.status = Status.refreshAnimate;
      }
    }
  }, {
    key: 'onDragStart',
    value: function onDragStart() {
      if (!this.getEnable()) return;
      this.status = Status.dragStart;

      var _getOffset = (0, _getOffset4.default)(this.trigger),
          top = _getOffset.top;

      if (top === this.initTop) {
        this.draging = true;
      }
      this.forceUpdate();
    }
  }, {
    key: 'onDrag',
    value: function onDrag(pos, event) {
      if (!this.getEnable()) return;
      if (pos.y < 0) return;

      // 消除误差
      var initTop = this.initTop;
      var threshold = this.props.threshold;

      var _getOffset2 = (0, _getOffset4.default)(this.trigger),
          top = _getOffset2.top;

      if (this.refreshing || top < initTop) {
        this.draging = false;
        return;
      }

      if (top === initTop && !this.draging) {
        this.draging = true;
        this.drager.reset(event);
      }

      if (this.draging && pos.y > 0) {
        event.preventDefault();
        event.stopPropagation();
      }
      this.oldY = this.y;
      this.y = pos.y;
      if (this.y < 0) {
        this.y = 1;
      }
      if (this.oldY < threshold && this.y >= threshold || this.oldY > threshold && this.y <= threshold) {
        this.forceUpdate();
      }
      this.triggerStyle(this.props.showRefreshing);
    }
  }, {
    key: 'onDragEnd',
    value: function onDragEnd(pos) {
      if (!this.getEnable()) return;
      if (pos.y <= 0) {
        this.clearState();
        return;
      }

      var canRefresh = pos.y >= this.props.threshold && this.draging;
      this.status = Status.dragAnimate;
      if (canRefresh) {
        this.draging = false;

        if (!this.props.refreshing) {
          this.props.onRefresh();
        }
      } else {
        this.y = 0;
        (0, _transitionEnd2.default)(this.trigger, this.clearState.bind(this));
      }
      this.triggerStyle(this.props.showRefreshing);
    }
  }, {
    key: 'getEnable',
    value: function getEnable() {
      if (this.props.getScrollContainer && this.props.getScrollContainer()) {
        return this.props.getScrollContainer().scrollTop === 0 && !this.props.refreshing;
      }
      return !this.props.refreshing;
    }
  }, {
    key: 'bindDrag',
    value: function bindDrag() {
      // const drager = new Drag(this.$container);
      this.drager = new _Drag2.default(this.$container);
      this.initTop = (0, _getOffset4.default)(this.trigger).top;
      this.status = Status.ready;

      this.drager.start(this.onDragStart.bind(this));
      this.drager.drag(this.onDrag.bind(this));
      this.drager.end(this.onDragEnd.bind(this));
    }
  }, {
    key: 'clearState',
    value: function clearState() {
      this.status = Status.ready;
      this.draging = false;
      this.y = 0;
    }
  }, {
    key: 'circularStyle',
    value: function circularStyle(showRefreshing) {
      var threshold = this.props.threshold;

      var y = Math.min(this.y, threshold);
      var ele = this.innerNode;

      var opacity = 0;
      if (this.refreshing) {
        opacity = 1;
      } else {
        opacity = y >= threshold ? 0.8 : op(y / this.max);
      }

      if (showRefreshing === false) {
        opacity = 0.8;
      }
      ele.style.opacity = opacity;
    }
  }, {
    key: 'refreshText',
    value: function refreshText() {
      var _props = this.props,
          threshold = _props.threshold,
          refreshingText = _props.refreshingText,
          afterPullLoadText = _props.afterPullLoadText,
          beforePullLoadText = _props.beforePullLoadText;

      if (this.refreshing) {
        return refreshingText;
      }
      if (this.draging) {
        var text = this.y >= threshold ? afterPullLoadText : beforePullLoadText;
        return text;
      }

      return '';
    }
  }, {
    key: 'triggerStyle',
    value: function triggerStyle(showRefreshing) {
      var y = 0;
      var ele = this.trigger;

      if (this.refreshing) {
        y = this.props.threshold;
      }
      if (this.draging) {
        y = this.y;
      }
      if (showRefreshing === false) {
        y = 0;
        ele.style.visibility = 'hidden';
      } else {
        ele.style.visibility = 'visible';
      }
      ele.style.WebkitTransform = 'translate3d(0, ' + y + 'px, 0)';
      ele.style.transform = 'translate3d(0, ' + y + 'px, 0)';
      this.circularStyle(showRefreshing);
    }
  }, {
    key: 'renderIcon',
    value: function renderIcon() {
      if (!this.props.showIcon) return null;

      var icon = this.props.refreshIcon;
      if (!icon) {
        icon = _react2.default.createElement(_Loading2.default, { className: (0, _classnames2.default)('refresh-svg-icon') });
      }

      return icon;
    }
  }, {
    key: 'renderRefreshText',
    value: function renderRefreshText() {
      var refreshText = this.refreshText();

      if (!this.props.showText || !refreshText) return null;

      return _react2.default.createElement(
        'div',
        { className: 'refresh-text', key: 'refresh-text' },
        refreshText
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props2 = this.props,
          className = _props2.className,
          children = _props2.children,
          showRefreshing = _props2.showRefreshing,
          refreshing = _props2.refreshing,
          onRefresh = _props2.onRefresh,
          threshold = _props2.threshold,
          beforePullLoadText = _props2.beforePullLoadText,
          afterPullLoadText = _props2.afterPullLoadText,
          refreshingText = _props2.refreshingText,
          refreshIcon = _props2.refreshIcon,
          showIcon = _props2.showIcon,
          showText = _props2.showText,
          getScrollContainer = _props2.getScrollContainer,
          otherProps = _objectWithoutProperties(_props2, ['className', 'children', 'showRefreshing', 'refreshing', 'onRefresh', 'threshold', 'beforePullLoadText', 'afterPullLoadText', 'refreshingText', 'refreshIcon', 'showIcon', 'showText', 'getScrollContainer']);

      return _react2.default.createElement(
        'div',
        _extends({
          ref: function ref(node) {
            _this3.$container = node;
          },
          className: (0, _classnames2.default)(_Context2.default.prefixClass('refresh-control'), this.status, className, {
            refreshing: this.refreshing,
            draging: this.draging
          })
        }, otherProps),
        _react2.default.createElement(
          'div',
          {
            key: 'refreshControl',
            ref: function ref(c) {
              _this3.innerNode = c;
            },
            className: (0, _classnames2.default)(_Context2.default.prefixClass('refresh-control-inner'))
          },
          this.renderIcon(),
          this.renderRefreshText()
        ),
        _react2.default.createElement(
          'div',
          {
            ref: function ref(node) {
              _this3.trigger = node;
            },
            className: (0, _classnames2.default)('needsclick', _Context2.default.prefixClass('refresh-control-area'))
          },
          children
        )
      );
    }
  }, {
    key: 'max',
    get: function get() {
      return this.props.max;
    }
  }, {
    key: 'refreshing',
    get: function get() {
      return this.props.refreshing;
    }
  }, {
    key: 'draging',
    get: function get() {
      return this._draging;
    },
    set: function set(draging) {
      this._draging = draging;
    }
  }, {
    key: 'y',
    get: function get() {
      return Math.min(Math.max(this._y, 0), this.max);
    },
    set: function set(y) {
      this._y = y;
    }
  }]);

  return RefreshControl;
}(_react2.default.Component);

RefreshControl.propTypes = {
  refreshing: _propTypes2.default.bool,
  onRefresh: _propTypes2.default.func,
  beforePullLoadText: _propTypes2.default.string,
  afterPullLoadText: _propTypes2.default.string,
  refreshingText: _propTypes2.default.string,
  threshold: _propTypes2.default.number,
  max: _propTypes2.default.number,
  className: _propTypes2.default.string,
  children: _propTypes2.default.any,
  refreshIcon: _propTypes2.default.element,
  showIcon: _propTypes2.default.bool,
  showText: _propTypes2.default.bool,
  showRefreshing: _propTypes2.default.bool,
  getScrollContainer: _propTypes2.default.func
};
RefreshControl.defaultProps = {
  refreshing: false,
  onRefresh: function onRefresh() {},

  threshold: 74,
  max: 110,
  className: '',
  children: null,
  beforePullLoadText: '下拉显示更多',
  afterPullLoadText: '松开显示更多',
  refreshingText: '加载中...',
  refreshIcon: null,
  showIcon: true,
  showText: true,
  showRefreshing: true,
  getScrollContainer: undefined
};


(0, _reactLifecyclesCompat.polyfill)(RefreshControl);

exports.default = RefreshControl;
module.exports = exports['default'];