"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getOffset;
function getOffset(el) {
  if (el) {
    var box = el.getBoundingClientRect();
    var _document = document,
        body = _document.body;

    var clientTop = el.clientTop || body.clientTop || 0;
    var clientLeft = el.clientLeft || body.clientLeft || 0;
    var scrollTop = window.pageYOffset || el.scrollTop;
    var scrollLeft = window.pageXOffset || el.scrollLeft;

    return {
      top: box.top + scrollTop - clientTop,
      left: box.left + scrollLeft - clientLeft
    };
  }
  return {
    top: 0,
    left: 0
  };
}
module.exports = exports["default"];