'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames3 = require('classnames');

var _classnames4 = _interopRequireDefault(_classnames3);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Badge = require('../Badge');

var _Badge2 = _interopRequireDefault(_Badge);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Item = function (_React$Component) {
  _inherits(Item, _React$Component);

  function Item() {
    _classCallCheck(this, Item);

    return _possibleConstructorReturn(this, (Item.__proto__ || Object.getPrototypeOf(Item)).apply(this, arguments));
  }

  _createClass(Item, [{
    key: 'renderImg',
    value: function renderImg() {
      var _props = this.props,
          img = _props.img,
          prefixCls = _props.prefixCls;

      if (typeof img === 'string') {
        return _react2.default.createElement('img', { alt: '', className: prefixCls + '-img', src: img });
      }
      return img;
    }
  }, {
    key: 'renderAvatar',
    value: function renderAvatar() {
      var _props2 = this.props,
          avatar = _props2.avatar,
          prefixCls = _props2.prefixCls;

      if (typeof avatar === 'string') {
        return _react2.default.createElement('img', { alt: '', className: prefixCls + '-avatar', src: avatar });
      }
      return avatar;
    }
  }, {
    key: 'renderTitle',
    value: function renderTitle() {
      var _props3 = this.props,
          title = _props3.title,
          prefixCls = _props3.prefixCls,
          badgePosition = _props3.badgePosition;

      if (!title) return null;
      return _react2.default.createElement(
        'div',
        { className: (0, _classnames4.default)(prefixCls + '-title', _defineProperty({}, badgePosition, true))
        },
        title,
        badgePosition === 'indicator' ? null : this.renderBadge()
      );
    }
  }, {
    key: 'renderBadge',
    value: function renderBadge() {
      var _props4 = this.props,
          badge = _props4.badge,
          prefixCls = _props4.prefixCls;

      var className = prefixCls + '-badge';
      if (typeof badge === 'string') {
        return _react2.default.createElement(_Badge2.default, { text: badge, className: className });
      } else if (typeof badge === 'number') {
        return _react2.default.createElement(_Badge2.default, { count: badge, className: className });
      } else if (typeof badge === 'boolean') {
        return _react2.default.createElement(_Badge2.default, { dot: true, className: className });
      }
      return badge;
    }
  }, {
    key: 'renderDes',
    value: function renderDes() {
      var _props5 = this.props,
          description = _props5.description,
          prefixCls = _props5.prefixCls,
          desMaxLine = _props5.desMaxLine;

      if (description) {
        return _react2.default.createElement(
          'div',
          { className: prefixCls + '-des' },
          _react2.default.createElement(
            'div',
            {
              className: prefixCls + '-des-inner',
              style: {
                WebkitLineClamp: desMaxLine
              }
            },
            description
          )
        );
      }
      return null;
    }
  }, {
    key: 'renderExtra',
    value: function renderExtra() {
      var _props6 = this.props,
          extra = _props6.extra,
          prefixCls = _props6.prefixCls;

      if (extra) {
        return _react2.default.createElement(
          'div',
          { className: prefixCls + '-extra' },
          _react2.default.createElement(
            'div',
            { className: prefixCls + '-extra-inner' },
            extra
          )
        );
      }
      return null;
    }
  }, {
    key: 'render',
    value: function render() {
      var _classnames2,
          _this2 = this;

      var _props7 = this.props,
          prefixCls = _props7.prefixCls,
          className = _props7.className,
          borderType = _props7.borderType,
          badgePosition = _props7.badgePosition,
          _onClick = _props7.onClick;

      return _react2.default.createElement(
        'div',
        {
          className: (0, _classnames4.default)((_classnames2 = {}, _defineProperty(_classnames2, prefixCls, true), _defineProperty(_classnames2, className, !!className), _defineProperty(_classnames2, borderType, !!borderType), _classnames2)),
          onClick: function onClick() {
            _onClick(_this2.props);
          }
        },
        this.renderImg(),
        this.renderAvatar(),
        _react2.default.createElement(
          'div',
          { className: prefixCls + '-content' },
          this.renderTitle(),
          this.renderDes()
        ),
        badgePosition === 'indicator' ? this.renderBadge() : null,
        this.renderExtra()
      );
    }
  }]);

  return Item;
}(_react2.default.Component);

Item.propTypes = {
  prefixCls: _propTypes2.default.string,
  className: _propTypes2.default.string,
  img: _propTypes2.default.string,
  avatar: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),
  title: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),
  description: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),
  badge: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element, _propTypes2.default.number, _propTypes2.default.bool]),
  badgePosition: _propTypes2.default.string,
  desMaxLine: _propTypes2.default.number,
  extra: _propTypes2.default.any,
  borderType: _propTypes2.default.string,
  onClick: _propTypes2.default.func
};
Item.defaultProps = {
  prefixCls: 't-scroll-list-item',
  desMaxLine: 2,
  className: undefined,
  img: undefined,
  avatar: undefined,
  title: undefined,
  description: undefined,
  badge: undefined,
  badgePosition: 'followTitle', // indicator/followTitle/titleRight
  extra: undefined,
  borderType: '',
  onClick: function onClick() {}
};
exports.default = Item;
module.exports = exports['default'];