'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Context = require('../Context');

var _Context2 = _interopRequireDefault(_Context);

var _InfiniteScroll = require('../InfiniteScroll');

var _InfiniteScroll2 = _interopRequireDefault(_InfiniteScroll);

var _Refreshcontrol = require('../Refreshcontrol');

var _Refreshcontrol2 = _interopRequireDefault(_Refreshcontrol);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * ScrollView Component for SaltUI
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author xiaohe.wp
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2018-2019, SaltUI Team.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var ScrollView = function (_React$Component) {
  _inherits(ScrollView, _React$Component);

  function ScrollView() {
    _classCallCheck(this, ScrollView);

    return _possibleConstructorReturn(this, (ScrollView.__proto__ || Object.getPrototypeOf(ScrollView)).apply(this, arguments));
  }

  _createClass(ScrollView, [{
    key: 'tryWrapRefreshControl',
    value: function tryWrapRefreshControl() {
      var _this2 = this;

      var _props = this.props,
          refreshControl = _props.refreshControl,
          _props$refreshControl = _props.refreshControlOptions,
          refreshControlOptions = _props$refreshControl === undefined ? {} : _props$refreshControl;

      var element = null;

      if (refreshControl) {
        element = _react2.default.createElement(_Refreshcontrol2.default, _extends({
          key: 'refreshControl',
          getScrollContainer: function getScrollContainer() {
            return _this2.scrollView;
          }
        }, refreshControlOptions, {
          className: _Context2.default.prefixClass('scroll-view-inner')
        }));
      } else {
        element = _react2.default.createElement('div', { key: 'scroll-inner', className: _Context2.default.prefixClass('scroll-view-inner') });
      }

      return _react2.default.cloneElement(element, {
        children: this.props.children
      });
    }
  }, {
    key: 'tryEmitScrollEvent',
    value: function tryEmitScrollEvent() {
      if (this.infiniteScroll) {
        this.infiniteScroll.tryEmitScrollEvent();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      return _react2.default.createElement(
        _InfiniteScroll2.default,
        _extends({
          key: 'infiniteScroll',
          ref: function ref(_ref) {
            _this3.infiniteScroll = _ref;
          },
          enabled: this.props.infiniteScroll
        }, this.props.infiniteScrollOptions, {
          getDOMNode: function getDOMNode(node) {
            if (node) {
              _this3.scrollNode = node;
            }
          }
        }),
        _react2.default.createElement(
          'div',
          {
            className: (0, _classnames2.default)(_Context2.default.prefixClass('scroll-view'), this.props.className)
          },
          this.tryWrapRefreshControl()
        )
      );
    }
  }]);

  return ScrollView;
}(_react2.default.Component);

ScrollView.displayName = 'ScrollView';
ScrollView.defaultProps = {
  refreshControl: false,
  refreshControlOptions: {},
  infiniteScroll: false,
  infiniteScrollOptions: {},
  className: undefined,
  children: undefined
};
ScrollView.propTypes = {
  className: _propTypes2.default.string,
  refreshControl: _propTypes2.default.bool,
  refreshControlOptions: _propTypes2.default.object,

  infiniteScroll: _propTypes2.default.bool,
  infiniteScrollOptions: _propTypes2.default.object,
  children: _propTypes2.default.any
};
exports.default = ScrollView;
module.exports = exports['default'];