'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactLifecyclesCompat = require('react-lifecycles-compat');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _pick = require('lodash/pick');

var _pick2 = _interopRequireDefault(_pick);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Context = require('../Context');

var _Context2 = _interopRequireDefault(_Context);

var _Element = require('./tpls/Element');

var _Element2 = _interopRequireDefault(_Element);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Skeleton Component for Skeleton
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author lj124435
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var Skeleton = function (_React$Component) {
  _inherits(Skeleton, _React$Component);

  function Skeleton() {
    _classCallCheck(this, Skeleton);

    return _possibleConstructorReturn(this, (Skeleton.__proto__ || Object.getPrototypeOf(Skeleton)).apply(this, arguments));
  }

  _createClass(Skeleton, [{
    key: 'getSkeletonContent',
    value: function getSkeletonContent(type, index) {
      var animate = this.props.animate;

      if (type === 1) {
        return _react2.default.createElement(
          'div',
          { key: type + '-' + index, className: (0, _classnames2.default)(_Context2.default.prefixClass('skeleton-wrapper')) },
          _react2.default.createElement(
            'div',
            { className: (0, _classnames2.default)(_Context2.default.prefixClass('skeleton-left-wrapper')) },
            _react2.default.createElement(_Element2.default, { className: 'skeleton-circle', animate: animate })
          ),
          _react2.default.createElement(
            'div',
            { className: (0, _classnames2.default)(_Context2.default.prefixClass('skeleton-right-wrapper')) },
            _react2.default.createElement(_Element2.default, { className: 'skeleton-text-bar', animate: animate }),
            _react2.default.createElement(_Element2.default, { className: 'skeleton-text-bar', animate: animate })
          )
        );
      } else if (type === 2) {
        return _react2.default.createElement(
          'div',
          { key: type + '-' + index, className: (0, _classnames2.default)(_Context2.default.prefixClass('skeleton-wrapper')) },
          _react2.default.createElement(
            'div',
            { className: (0, _classnames2.default)(_Context2.default.prefixClass('skeleton-left-wrapper')) },
            _react2.default.createElement(_Element2.default, { className: 'skeleton-image-small', animate: animate })
          ),
          _react2.default.createElement(
            'div',
            { className: (0, _classnames2.default)(_Context2.default.prefixClass('skeleton-right-wrapper')) },
            _react2.default.createElement(_Element2.default, { className: 'skeleton-text-bar', animate: animate }),
            _react2.default.createElement(_Element2.default, { className: 'skeleton-text-bar', animate: animate })
          )
        );
      } else if (type === 3) {
        return _react2.default.createElement(
          'div',
          { key: type + '-' + index, className: (0, _classnames2.default)(_Context2.default.prefixClass('skeleton-wrapper')) },
          _react2.default.createElement(_Element2.default, { className: 'skeleton-image-big', animate: animate }),
          _react2.default.createElement(
            'div',
            { className: (0, _classnames2.default)(_Context2.default.prefixClass('skeleton-operation-bar')) },
            _react2.default.createElement(_Element2.default, { className: 'skeleton-operation-left', animate: animate }),
            _react2.default.createElement(_Element2.default, { className: 'skeleton-operation-mid', animate: animate }),
            _react2.default.createElement(_Element2.default, { className: 'skeleton-operation-right', animate: animate })
          )
        );
      }
      return null;
    }
  }, {
    key: 'render',
    value: function render() {
      var t = this;
      var _props = this.props,
          visible = _props.visible,
          rows = _props.rows,
          type = _props.type,
          className = _props.className;

      var contentList = [];
      for (var i = 0; i < rows; i++) {
        contentList.push(t.getSkeletonContent(type, i));
      }
      if (visible) {
        return _react2.default.createElement(
          'div',
          { className: className },
          contentList
        );
      }
      return _react2.default.createElement('noscript', null);
    }
  }]);

  return Skeleton;
}(_react2.default.Component);

Skeleton.Element = _Element2.default;

Skeleton.defaultProps = {
  visible: true,
  animate: false,
  rows: 1,
  type: 1,
  className: ''
};

Skeleton.propTypes = {
  visible: _propTypes2.default.bool,
  animate: _propTypes2.default.bool,
  rows: _propTypes2.default.number,
  type: _propTypes2.default.number,
  className: _propTypes2.default.string
};

Skeleton.displayName = 'Skeleton';

var traversal = function traversal(node, number) {
  var styleObj = (0, _pick2.default)(window.getComputedStyle(node, null), ['width', 'height', 'borderRadius', 'position', 'top', 'bottom', 'left', 'right', 'marginTop', 'marginBottom', 'marginLeft', 'marginRight', 'paddingTop', 'paddingBottom', 'paddingLeft', 'paddingRight', 'display', 'flex', 'flexDirection']);
  var traversalLevel = number || 4;
  if (node.children.length > 0 && traversalLevel > 1) {
    return '<div style={' + JSON.stringify(styleObj) + '}>' + Array.prototype.map.call(node.children, function (item) {
      return traversal(item, traversalLevel - 1);
    }).join('') + '</div>';
  }
  return '<Element animate style={' + JSON.stringify(styleObj) + '}/>';
};

window.node2skeleton = function (node, number) {
  console.log(traversal(node, number));
};

(0, _reactLifecyclesCompat.polyfill)(Skeleton);
exports.default = Skeleton;
module.exports = exports['default'];