'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _reactLifecyclesCompat = require('react-lifecycles-compat');

var _Context = require('../Context');

var _Context2 = _interopRequireDefault(_Context);

var _Step = require('./Step');

var _Step2 = _interopRequireDefault(_Step);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Steps Component for SaltUI
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author muwen.lb
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2018-2019, SaltUI Team.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var prefixClass = _Context2.default.prefixClass;


var computedWidth = function computedWidth(offsetWidth, length, itemsWidth) {
  var width = Math.floor(offsetWidth);
  var tw = itemsWidth.reduce(function (prew, w) {
    return prew + w;
  }, 0);
  var dw = Math.floor((width - tw) / length) - 1;
  return {
    width: width,
    dw: dw
  };
};

var Steps = function (_React$Component) {
  _inherits(Steps, _React$Component);

  function Steps(props) {
    _classCallCheck(this, Steps);

    var _this = _possibleConstructorReturn(this, (Steps.__proto__ || Object.getPrototypeOf(Steps)).call(this, props));

    _this.state = {
      init: false,
      tailWidth: 0,
      itemsWidth: [],
      previousStepsWidth: 0,
      prevProps: {}
    };
    return _this;
  }

  _createClass(Steps, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      if (this.props.direction === 'vertical') {
        return;
      }

      var $dom = this.root;
      var len = $dom.children.length - 1;

      var itemsWidth = new Array(len + 1);
      for (var i = 0; i <= len; i++) {
        itemsWidth[i] = this.props.maxDescriptionWidth;
      }

      var _computedWidth = computedWidth(this.root.offsetWidth, len, itemsWidth),
          dw = _computedWidth.dw,
          width = _computedWidth.width;

      if (dw <= 0) {
        this.setState({
          itemsWidth: itemsWidth,
          previousStepsWidth: width
        });
        return;
      }
      this.setState({
        init: true,
        tailWidth: dw,
        itemsWidth: itemsWidth,
        previousStepsWidth: width,
        prevProps: this.props
      });

      /*
       * 把最后一个元素设置为absolute，是为了防止动态添加元素后滚动条出现导致的布局问题。
       * 未来不考虑ie8一类的浏览器后，会采用纯css来避免各种问题。
       */
      $dom.children[len].style.position = 'absolute';

      this.fixLastDetailHeight();

      /*
       * 下面的代码是为了兼容window系统下滚动条出现后会占用宽度的问题。
       * componentDidMount时滚动条还不一定出现了，这时候获取的宽度可能不是最终宽度。
       * 对于滚动条不占用宽度的浏览器，下面的代码也不二次render，resize里面会判断要不要更新。
       */
      setTimeout(function () {
        _this2.resize();
      });

      this.resizeBind = this.resize.bind(this);

      if (window.attachEvent) {
        window.attachEvent('onresize', this.resizeBind);
      } else {
        window.addEventListener('resize', this.resizeBind);
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.resize();
      var $dom = this.root;

      var len = $dom.children.length - 1;
      /*
       * 把最后一个元素设置为absolute，是为了防止动态添加元素后滚动条出现导致的布局问题。
       * 未来不考虑ie8一类的浏览器后，会采用纯css来避免各种问题。
       */
      for (var i = 0; i <= len; i++) {
        $dom.children[i].style.position = 'relative';
      }
      $dom.children[len].style.position = 'absolute';
      this.fixLastDetailHeight();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.props.direction === 'vertical') {
        return;
      }
      if (window.attachEvent) {
        window.detachEvent('onresize', this.resizeBind);
      } else {
        window.removeEventListener('resize', this.resizeBind);
      }
    }
  }, {
    key: 'resize',
    value: function resize() {
      this.fixLastDetailHeight();

      var _computedWidth2 = computedWidth(this.root.offsetWidth, this.props.children.length - 1, this.state.itemsWidth),
          width = _computedWidth2.width,
          dw = _computedWidth2.dw;

      if (this.state.previousStepsWidth === width) {
        return;
      }
      if (dw <= 0) {
        return;
      }
      this.setState({
        init: true,
        tailWidth: dw,
        previousStepsWidth: width
      });
    }
  }, {
    key: 'fixLastDetailHeight',
    value: function fixLastDetailHeight() {
      /*
       * 把整体高度调整为适合高度,处理最后一个detail是绝对定位的问题
       * */
      var $dom = this.root;
      var len = $dom.children.length - 1;
      var $domLastDetail = $dom.children[len];
      if (this.props.currentDetail === len && $dom.offsetHeight <= $domLastDetail.offsetHeight) {
        $dom.style.height = $domLastDetail.offsetHeight + 'px';
      } else {
        $dom.style.height = 'auto';
      }
    }
  }, {
    key: 'renderCurrentTitle',
    value: function renderCurrentTitle() {
      var _props = this.props,
          current = _props.current,
          children = _props.children;

      var currentTitle = children[current].props.title;
      return _react2.default.createElement(
        'div',
        { className: prefixClass('current-title') },
        currentTitle
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _classnames,
          _this3 = this;

      var current = this.props.current;
      var _props2 = this.props,
          className = _props2.className,
          children = _props2.children,
          maxDescriptionWidth = _props2.maxDescriptionWidth,
          iconPrefix = _props2.iconPrefix,
          direction = _props2.direction,
          showIcon = _props2.showIcon,
          type = _props2.type,
          showDetail = _props2.showDetail,
          currentDetail = _props2.currentDetail,
          onChange = _props2.onChange,
          showCurrentTitle = _props2.showCurrentTitle;

      var len = children.length - 1;
      var iws = this.state.itemsWidth;
      var clsName = (0, _classnames3.default)(prefixClass('steps'), className, (_classnames = {}, _defineProperty(_classnames, prefixClass('steps-vertical'), direction === 'vertical'), _defineProperty(_classnames, prefixClass('steps-type-' + type), direction !== 'vertical'), _defineProperty(_classnames, prefixClass('steps-noicon'), !showIcon), _classnames));

      var fixStyle = void 0;
      if (direction !== 'vertical') {
        // fix #5
        if (type === 'default') {
          var descItemsCount = children.filter(function (d) {
            return d.props.description;
          }).length;
          if (descItemsCount > 0 && descItemsCount !== len + 1) {
            fixStyle = {
              marginTop: 70
            };
          }
        }
      }
      if (typeof current !== 'number') {
        current = Number(current);
      }
      return _react2.default.createElement(
        'div',
        { className: prefixClass('steps-wrapper') },
        _react2.default.createElement(
          'div',
          {
            className: clsName,
            ref: function ref(c) {
              _this3.root = c;
            }
          },
          _react2.default.Children.map(children, function (ele, idx) {
            var np = {
              stepNumber: showIcon ? (idx + 1).toString() : '',
              stepLast: idx === len,
              tailWidth: iws.length === 0 || idx === len ? 'auto' : (iws[idx] || 0) + _this3.state.tailWidth,
              iconPrefix: iconPrefix,
              maxDescriptionWidth: maxDescriptionWidth,
              fixStyle: fixStyle,
              showDetail: showDetail && currentDetail === idx && direction !== 'vertical' && type !== 'long-desc',
              detailContentFixStyle: {
                marginLeft: !Number.isNaN(-(iws[idx] + _this3.state.tailWidth) * idx) ? -(iws[idx] + _this3.state.tailWidth) * idx : 0,
                width: _this3.state.previousStepsWidth
              },
              onChange: onChange,
              showCurrentTitle: showCurrentTitle,
              showIcon: showIcon,
              direction: direction,
              hasDetail: showDetail && direction !== 'vertical' && type !== 'long-desc'
            };
            if (!ele.props.status) {
              if (idx === current) {
                np.status = 'process';
              } else if (idx < current) {
                np.status = 'finish';
              } else {
                np.status = 'wait';
              }
            }
            return _react2.default.cloneElement(ele, np);
          }, this)
        ),
        showCurrentTitle ? this.renderCurrentTitle() : null
      );
    }
  }], [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(nextProps, _ref) {
      var prevProps = _ref.prevProps,
          previousStepsWidth = _ref.previousStepsWidth;
      var children = nextProps.children,
          maxDescriptionWidth = nextProps.maxDescriptionWidth;

      if (_react2.default.Children.count(children) === _react2.default.Children.count(prevProps.children)) {
        return null;
      }
      if (prevProps.direction === 'vertical') {
        return null;
      }
      var len = children.length - 1;
      var itemsWidth = new Array(len + 1);
      for (var i = 0; i <= len; i++) {
        itemsWidth[i] = maxDescriptionWidth;
      }

      var _computedWidth3 = computedWidth(previousStepsWidth, len, itemsWidth),
          dw = _computedWidth3.dw;

      if (dw <= 0) {
        return {
          itemsWidth: itemsWidth,
          prevProps: nextProps
        };
      }
      return {
        init: true,
        tailWidth: dw,
        itemsWidth: itemsWidth,
        prevProps: nextProps
      };
    }
  }]);

  return Steps;
}(_react2.default.Component);

Steps.defaultProps = {
  className: '',
  iconPrefix: '',
  maxDescriptionWidth: 100,
  current: 0,
  direction: '',
  showIcon: true,
  type: 'default',
  showDetail: false,
  currentDetail: 0,
  onChange: function onChange() {},
  children: [],
  showCurrentTitle: false
};

// http://facebook.github.io/react/docs/reusable-components.html
Steps.propTypes = {
  className: _propTypes2.default.string,
  iconPrefix: _propTypes2.default.string,
  maxDescriptionWidth: _propTypes2.default.number,
  current: _propTypes2.default.number,
  direction: _propTypes2.default.string,
  showIcon: _propTypes2.default.bool,
  type: _propTypes2.default.oneOf(['default', 'title-on-top', 'long-desc']),
  showDetail: _propTypes2.default.bool,
  currentDetail: _propTypes2.default.number,
  onChange: _propTypes2.default.func,
  children: _propTypes2.default.any,
  showCurrentTitle: _propTypes2.default.bool
};

Steps.displayName = 'Steps';
Steps.Step = _Step2.default;

(0, _reactLifecyclesCompat.polyfill)(Steps);

exports.default = Steps;
module.exports = exports['default'];