'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Badge = require('../Badge');

var _Badge2 = _interopRequireDefault(_Badge);

var _TabBarItemIcon = require('./TabBarItemIcon');

var _TabBarItemIcon2 = _interopRequireDefault(_TabBarItemIcon);

var _TabBarItemTitle = require('./TabBarItemTitle');

var _TabBarItemTitle2 = _interopRequireDefault(_TabBarItemTitle);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TabBarItemBadge = function (_React$Component) {
  _inherits(TabBarItemBadge, _React$Component);

  function TabBarItemBadge() {
    _classCallCheck(this, TabBarItemBadge);

    return _possibleConstructorReturn(this, (TabBarItemBadge.__proto__ || Object.getPrototypeOf(TabBarItemBadge)).apply(this, arguments));
  }

  _createClass(TabBarItemBadge, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          badge = _props.badge,
          badgeStyle = _props.badgeStyle,
          iconHeight = _props.iconHeight,
          active = _props.active,
          showTitle = _props.showTitle;

      var contentBadge = [];
      if (badge && typeof badge === 'number') {
        var badgeItem = _react2.default.createElement(
          _Badge2.default,
          { key: 'badge_number', count: badge, style: badgeStyle },
          _react2.default.createElement(_TabBarItemIcon2.default, _extends({}, this.props, { iconHeight: iconHeight, active: active })),
          showTitle ? _react2.default.createElement(_TabBarItemTitle2.default, _extends({}, this.props, { active: active })) : null
        );
        contentBadge.push(badgeItem);
      } else if (badge && typeof badge === 'string') {
        var _badgeItem = _react2.default.createElement(
          _Badge2.default,
          { key: 'badge_string', text: badge, style: badgeStyle },
          _react2.default.createElement(_TabBarItemIcon2.default, _extends({}, this.props, { iconHeight: iconHeight, active: active })),
          showTitle ? _react2.default.createElement(_TabBarItemTitle2.default, _extends({}, this.props, { active: active })) : null
        );
        contentBadge.push(_badgeItem);
      } else if (badge && badge.constructor === Object) {
        var _badgeItem2 = _react2.default.createElement(
          _Badge2.default,
          _extends({}, badge, { key: 'badge_object', style: badgeStyle }),
          _react2.default.createElement(_TabBarItemIcon2.default, _extends({}, this.props, { iconHeight: iconHeight, active: active })),
          showTitle ? _react2.default.createElement(_TabBarItemTitle2.default, _extends({}, this.props, { active: active })) : null
        );
        contentBadge.push(_badgeItem2);
      } else {
        var _badgeItem3 = _react2.default.createElement(
          'div',
          { key: 'badge_others' },
          _react2.default.createElement(_TabBarItemIcon2.default, _extends({}, this.props, { iconHeight: iconHeight, active: active })),
          showTitle ? _react2.default.createElement(_TabBarItemTitle2.default, _extends({}, this.props, { active: active })) : null
        );
        contentBadge.push(_badgeItem3);
      }
      return _react2.default.createElement(
        'div',
        null,
        contentBadge
      );
    }
  }]);

  return TabBarItemBadge;
}(_react2.default.Component);

TabBarItemBadge.displayName = 'TabBarItemBadge';
TabBarItemBadge.propTypes = {
  badge: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.number, _propTypes2.default.string, _propTypes2.default.object]),
  badgeStyle: _propTypes2.default.object,
  iconHeight: _propTypes2.default.number,
  active: _propTypes2.default.bool,
  showTitle: _propTypes2.default.bool
};
TabBarItemBadge.defaultProps = {
  showTitle: true,
  badge: undefined,
  badgeStyle: undefined,
  iconHeight: undefined,
  active: undefined
};
exports.default = TabBarItemBadge;
module.exports = exports['default'];