'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames5 = require('classnames');

var _classnames6 = _interopRequireDefault(_classnames5);

var _cloneDeep = require('lodash/cloneDeep');

var _cloneDeep2 = _interopRequireDefault(_cloneDeep);

var _reactLifecyclesCompat = require('react-lifecycles-compat');

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _chunk = require('lodash/chunk');

var _chunk2 = _interopRequireDefault(_chunk);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Scroller = require('../Scroller');

var _Scroller2 = _interopRequireDefault(_Scroller);

var _Context = require('../Context');

var _Context2 = _interopRequireDefault(_Context);

var _Pagination = require('../Pagination');

var _Pagination2 = _interopRequireDefault(_Pagination);

var _AngleRight = require('salt-icon/lib/AngleRight');

var _AngleRight2 = _interopRequireDefault(_AngleRight);

var _Popup = require('../Popup');

var _Popup2 = _interopRequireDefault(_Popup);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Table Component for SaltUI
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author sujingjing
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2018-2019, SaltUI Team.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var Table = function (_React$Component) {
  _inherits(Table, _React$Component);

  function Table(props) {
    _classCallCheck(this, Table);

    var _this = _possibleConstructorReturn(this, (Table.__proto__ || Object.getPrototypeOf(Table)).call(this, props));

    _this.toggleSubTable = function (subData, rowData) {
      var columns = subData.columns;
      _this.subTablePageData = (0, _chunk2.default)(subData.data, _this.props.subTablePageSize);
      _this.setState({
        subTableVisible: !_this.state.subTableVisible,
        subTableData: _extends({}, subData, {
          data: _this.subTablePageData[0]
        }),
        rowData: rowData,
        subColumns: columns || []
      });
    };

    var hasSubTable = _this.hasSubTable();
    _this.state = {
      columns: Table.processColumns(props, hasSubTable),
      prevColumns: (0, _cloneDeep2.default)(props.columns),
      subTableVisible: false,
      subTableData: {},
      rowData: {},
      subColumns: [],
      // 是否存在子表格，用于初始状态下最右侧列的显示判断
      hasSubTable: hasSubTable
    };
    return _this;
  }

  /**
   * 为 column 添加默认值
   */


  _createClass(Table, [{
    key: 'hasSubTable',
    value: function hasSubTable() {
      var _ref = this.props.data || [],
          data = _ref.data;

      var ret = false;
      for (var i = 0; i < data.length; i++) {
        if (data[i] && data[i].data && data[i].data.length) {
          ret = true;
          break;
        }
      }
      return ret;
    }
  }, {
    key: 'renderActionColumn',
    value: function renderActionColumn(cellData, rowData, isSubTable) {
      var _this2 = this;

      if (rowData.data && rowData.data.length) {
        return _react2.default.createElement(_AngleRight2.default, {
          className: _Context2.default.prefixClass('table-row-item-icon'),
          style: {
            opacity: isSubTable ? 0 : 1
          },
          onClick: function onClick() {
            if (isSubTable) {
              return;
            }
            _this2.toggleSubTable({
              totalCount: rowData.data.length,
              currentPage: 1,
              data: rowData.data,
              columns: rowData.columns
            }, rowData);
          },
          width: 20,
          height: 18
        });
      }
      // 需要占位一下，否则会导致样式错误
      return _react2.default.createElement('div', { style: { display: 'inline-block' } });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.checkScroll(this.getIscroll());
    }
  }, {
    key: 'renderRow',
    value: function renderRow(options, isSubTable) {
      var _this3 = this;

      var rowData = options.rowData,
          index = options.index,
          columns = options.columns;

      return _react2.default.createElement(
        'div',
        {
          className: (0, _classnames6.default)(_Context2.default.prefixClass('table-row')),
          key: index
        },
        columns.map(function (column, i) {
          var _classnames;

          var rowItemStyle = {
            width: column.width,
            textAlign: column.align
          };
          var isActionColumn = column.dataKey === 'actionColumn';
          // todo don't support third subrow
          if (isActionColumn && !_this3.state.hasSubTable) {
            return null;
          }
          return _react2.default.createElement(
            'div',
            {
              className: (0, _classnames6.default)((_classnames = {
                firstRow: index === 0
              }, _defineProperty(_classnames, _Context2.default.prefixClass('table-row-item DIB omit'), true), _defineProperty(_classnames, _Context2.default.prefixClass('PL12 PR12'), !isActionColumn), _defineProperty(_classnames, _Context2.default.prefixClass('arrow-column'), isActionColumn), _classnames)),
              style: rowItemStyle,
              key: i
            },
            column.render ? column.render.call(_this3, rowData[column.dataKey], rowData, isSubTable) : rowData[column.dataKey] || '　'
          );
        })
      );
    }
  }, {
    key: 'renderHeader',
    value: function renderHeader(columns, isSubTable) {
      var _this4 = this;

      var cl = columns.length;
      return _react2.default.createElement(
        'div',
        {
          className: (0, _classnames6.default)(_Context2.default.prefixClass('table-header'))
        },
        _react2.default.createElement(
          'div',
          { className: _Context2.default.prefixClass('table-header-main') },
          columns.map(function (column, index) {
            var _classnames2;

            var headerItemStyle = {
              width: column.width,
              textAlign: column.align
            };
            var isActionColumn = column.dataKey === 'actionColumn';
            // todo don't support third subrow
            if (isActionColumn && !_this4.state.hasSubTable) {
              return null;
            }

            return _react2.default.createElement(
              'div',
              {
                className: (0, _classnames6.default)((_classnames2 = {
                  firstRow: index === 0,
                  lastRow: index === cl - 1
                }, _defineProperty(_classnames2, _Context2.default.prefixClass('table-header-item omit DIB'), !isActionColumn), _defineProperty(_classnames2, _Context2.default.prefixClass('PL12 PR12'), isActionColumn), _classnames2)),
                style: headerItemStyle,
                key: index
              },
              column.title
            );
          })
        )
      );
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.checkScroll(this.getIscroll());
    }
  }, {
    key: 'getIscroll',
    value: function getIscroll() {
      return this.scroller.scroller;
    }
  }, {
    key: 'handlePagerChange',
    value: function handlePagerChange(current, isSubTable) {
      console.log(current, isSubTable);
      var _props = this.props,
          onSubTablePagerChange = _props.onSubTablePagerChange,
          onPagerChange = _props.onPagerChange;

      if (isSubTable) {
        this.setState({
          subTableData: _extends({}, this.state.subTableData, {
            data: this.subTablePageData[current - 1]
          })
        });
        onSubTablePagerChange(current);
      } else {
        onPagerChange(current);
      }
    }
  }, {
    key: 'checkScroll',
    value: function checkScroll(iscroll) {
      var maxScrollX = iscroll.maxScrollX,
          startX = iscroll.startX;

      var scrollClassName = _Context2.default.prefixClass('table-fixed__has-scroll');

      if (this.leftFixed) {
        var classList = this.leftFixed.classList;
        if (startX !== undefined) {
          if (startX === 0) {
            classList.remove(scrollClassName);
          } else {
            classList.add(scrollClassName);
          }
        }
      }

      if (this.rightFixed) {
        var _classList = this.rightFixed.classList;

        if (startX !== undefined) {
          if (startX === maxScrollX || this.state.columns.length < 5) {
            _classList.remove(scrollClassName);
          } else {
            _classList.add(scrollClassName);
          }
        } else if (maxScrollX < 0) {
          _classList.add(scrollClassName);
        }
      }
    }
  }, {
    key: 'renderBody',
    value: function renderBody(columns, fixed, isSubTable) {
      var _this5 = this;

      var t = this;
      var data = isSubTable ? t.state.subTableData : t.props.data;
      var content = '';
      if (data.data && data.data.length) {
        content = data.data.map(function (item, index) {
          var last = false;
          if (index === data.data.length - 1) {
            last = true;
          }
          return _this5.renderRow({
            rowData: item,
            index: index,
            last: last,
            columns: columns,
            fixed: fixed
          }, isSubTable);
        });
      } else {
        content = t.renderEmptyContent(columns, fixed, isSubTable);
      }
      return _react2.default.createElement(
        'div',
        {
          className: (0, _classnames6.default)(_Context2.default.prefixClass('table-body FS12 FC6 BCf'))
        },
        content
      );
    }
  }, {
    key: 'renderEmptyContent',
    value: function renderEmptyContent(columns, fixed, isSubTable) {
      if (fixed) {
        return null;
      }
      var t = this;
      var emptyText = t.props.emptyText;

      var screenWidth = window.innerWidth || document.body.clientWidth;
      return _react2.default.createElement(
        'div',
        {
          className: (0, _classnames6.default)(_Context2.default.prefixClass('table-empty-content H40 FC9 FAC')),
          style: {
            width: screenWidth
          }
        },
        emptyText
      );
    }
  }, {
    key: 'renderPager',
    value: function renderPager(isSubTable) {
      var t = this;
      var _t$props = t.props,
          pageSize = _t$props.pageSize,
          subTablePageSize = _t$props.subTablePageSize;

      var data = isSubTable ? this.state.subTableData : t.props.data;
      if (isSubTable && data.totalCount <= subTablePageSize) {
        return null;
      }
      if (data.totalCount && data.currentPage) {
        return _react2.default.createElement(_Pagination2.default, {
          className: _Context2.default.prefixClass('table-pager'),
          total: data.totalCount,
          current: data.currentPage,
          onChange: function onChange(current) {
            t.handlePagerChange(current, isSubTable);
          },
          pageSize: isSubTable ? subTablePageSize : pageSize
        });
      }
      return null;
    }
  }, {
    key: 'getFixedColumns',
    value: function getFixedColumns(columns) {
      var _props2 = this.props,
          leftFixed = _props2.leftFixed,
          rightFixed = _props2.rightFixed;

      var leftFixedColumns = [];
      var rightFixedColumns = [];
      if (leftFixed || rightFixed) {
        if (leftFixed) {
          leftFixedColumns = columns.slice(0, leftFixed);
        }
        if (rightFixed) {
          rightFixedColumns = columns.slice(columns.length - rightFixed - 1, columns.length);
          if (rightFixedColumns.length === 1 && columns.length < 5) {
            rightFixedColumns = [];
          }
        }
      } else {
        columns.map(function (column) {
          if (column.fixed) {
            leftFixedColumns.push(column);
          } else if (column.rightFixed) {
            rightFixedColumns.push(column);
          }
        });
      }
      return {
        leftFixedColumns: leftFixedColumns,
        rightFixedColumns: rightFixedColumns
      };
    }
  }, {
    key: 'renderFixed',
    value: function renderFixed(columns, isSubTable) {
      var _this6 = this;

      var t = this;
      var scrollClassName = _Context2.default.prefixClass('table-fixed__has-scroll');
      var columnsValue = t.getFixedColumns(columns);
      return ['left', 'right'].map(function (direction) {
        var cols = columnsValue[direction + 'FixedColumns'];
        var onlyArrow = direction === 'right' && cols.length === 1;
        if (!cols.length || onlyArrow && columns.length < 5) {
          return null;
        }
        return _react2.default.createElement(
          'div',
          {
            key: direction,
            className: (0, _classnames6.default)(_Context2.default.prefixClass('table-' + direction + '-fixed PA'), _defineProperty({
              'only-arrow': onlyArrow
            }, scrollClassName, isSubTable && direction === 'right' && columns > 5)),
            ref: function ref(c) {
              _this6[direction + 'Fixed'] = c;
            }
          },
          t.props.showHeader ? _this6.renderHeader(cols, isSubTable) : null,
          t.renderBody(cols, true, isSubTable)
        );
      });
    }
  }, {
    key: 'renderSubTablePopup',
    value: function renderSubTablePopup() {
      var _this7 = this;

      var renderSubComp = this.props.renderSubComp;
      var _state = this.state,
          subTableVisible = _state.subTableVisible,
          subTableData = _state.subTableData,
          rowData = _state.rowData;

      return _react2.default.createElement(
        _Popup2.default,
        {
          content: renderSubComp ? function () {
            if (!subTableData.data || !subTableData.data.length) {
              return null;
            }
            return renderSubComp(rowData, subTableData);
          }() : this.renderTable(true),
          animationType: 'slide-up',
          onMaskClick: function onMaskClick() {
            _this7.setState({ subTableVisible: false });
          },
          visible: subTableVisible
        },
        null
      );
    }
  }, {
    key: 'renderTable',
    value: function renderTable(isSubTable) {
      var _this8 = this,
          _classnames4;

      var t = this;
      var _t$props2 = t.props,
          className = _t$props2.className,
          subTableClassName = _t$props2.subTableClassName,
          showPager = _t$props2.showPager;
      var _t$state = t.state,
          columns = _t$state.columns,
          subColumns = _t$state.subColumns;

      var subTableColumns = subColumns.length ? Table.processColumns({ columns: subColumns }) : columns;
      var scrollerProps = {
        ref: function ref(c) {
          _this8.scroller = c;
        },
        bounce: false,
        mouseWheel: !!_Context2.default.isPC,
        scrollX: true,
        scrollY: false,
        eventPassthrough: true,
        preventDefault: false,
        onScrollStart: function onScrollStart(iscroll) {
          _this8.checkScroll(iscroll);
        },
        onScrollEnd: function onScrollEnd(iscroll) {
          _this8.checkScroll(iscroll);
        }
      };
      var customClassName = isSubTable ? subTableClassName : className;
      return _react2.default.createElement(
        'div',
        {
          className: (0, _classnames6.default)(_Context2.default.prefixClass('FS12 PR'), (_classnames4 = {}, _defineProperty(_classnames4, customClassName, !!customClassName), _defineProperty(_classnames4, _Context2.default.prefixClass(isSubTable ? 'table sub-table' : 'table'), true), _defineProperty(_classnames4, 'hide-rows-split-line', t.props.hideSplitLine), _classnames4))
        },
        isSubTable ? _react2.default.createElement(
          'div',
          { className: 'sub-table-back', onClick: function onClick() {
              _this8.setState({ subTableVisible: false });
            } },
          '\u8FD4\u56DE'
        ) : null,
        _react2.default.createElement(
          'div',
          { style: { position: 'relative' } },
          _react2.default.createElement(
            _Scroller2.default,
            _extends({}, scrollerProps, { className: _Context2.default.prefixClass('table-content-container') }),
            _react2.default.createElement(
              'div',
              { ref: function ref(c) {
                  t.mainTable = c;
                }, className: _Context2.default.prefixClass('table-content') },
              t.props.showHeader ? this.renderHeader(isSubTable ? subTableColumns : columns, isSubTable) : null,
              t.renderBody(isSubTable ? subTableColumns : columns, false, isSubTable)
            )
          ),
          t.renderFixed(isSubTable ? subTableColumns : columns, isSubTable),
          showPager ? t.renderPager(isSubTable) : null
        ),
        isSubTable ? null : t.renderSubTablePopup()
      );
    }
  }, {
    key: 'render',
    value: function render() {
      return this.renderTable();
    }
  }], [{
    key: 'processColumns',
    value: function processColumns(props, hasSubTable) {
      // const newProps = props;
      var columns = (0, _cloneDeep2.default)(props.columns).map(function (column) {
        var width = column.width || 0.25;
        if (typeof width === 'string') {
          if (width.indexOf('%') !== -1) {
            width = parseInt(width, 10) / 100;
          } else if (width.indexOf('px') !== -1) {
            width = +width / 640;
          } else {
            width = +width;
          }
        }
        if (!width || width > 1 || width <= 0) {
          width = 0.25;
        }

        column.width = _Context2.default.rem(width * (hasSubTable && props.columns.length > 3 ? 598 : 640), 640);
        column.align = column.align || 'left';
        return column;
      });
      // arrow
      columns.push({
        dataKey: 'actionColumn',
        title: '',
        align: 'center',
        width: _Context2.default.rem(40, 640),
        rightFixed: true,
        render: function render(cellData, rowData, isSubTable) {
          return this.renderActionColumn(cellData, rowData, isSubTable);
        }
      });
      return columns;
    }
  }, {
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if (!(0, _isEqual2.default)(prevState.prevColumns, nextProps.columns)) {
        // 不在这里更新 this.columns 是因为后面 didUpdate 时还用的到。
        var columns = Table.processColumns(nextProps);
        return {
          columns: columns,
          prevColumns: (0, _cloneDeep2.default)(nextProps.columns)
        };
      }

      return null;
    }
  }]);

  return Table;
}(_react2.default.Component);

Table.defaultProps = {
  data: {},
  // 展示类型
  displayType: 'table',
  pageSize: 10,
  // 子表格显示行数
  subTablePageSize: 8,
  emptyText: '暂无数据',
  leftFixed: 0,
  hideSplitLine: false,
  rightFixed: 0,
  showHeader: true,
  onPagerChange: function onPagerChange() {},
  // 子表格翻页回调
  onSubTablePagerChange: function onSubTablePagerChange() {},
  columns: undefined,
  className: undefined,
  subTableClassName: undefined,
  renderSubComp: undefined,
  showPager: true
};

Table.propTypes = {
  columns: _propTypes2.default.array,
  data: _propTypes2.default.object,
  displayType: _propTypes2.default.oneOf(['table', 'list']),
  pageSize: _propTypes2.default.number,
  subTablePageSize: _propTypes2.default.number,
  onSubTablePagerChange: _propTypes2.default.func,
  emptyText: _propTypes2.default.string,
  className: _propTypes2.default.string,
  subTableClassName: _propTypes2.default.string,
  showHeader: _propTypes2.default.bool,
  leftFixed: _propTypes2.default.number,
  rightFixed: _propTypes2.default.number,
  hideSplitLine: _propTypes2.default.bool,
  onPagerChange: _propTypes2.default.func,
  renderSubComp: _propTypes2.default.func,
  showPager: _propTypes2.default.bool
};

Table.displayName = 'Table';
(0, _reactLifecyclesCompat.polyfill)(Table);

exports.default = Table;
module.exports = exports['default'];