'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames3 = require('classnames');

var _classnames4 = _interopRequireDefault(_classnames3);

var _CrossRound = require('salt-icon/lib/CrossRound');

var _CrossRound2 = _interopRequireDefault(_CrossRound);

var _Context = require('../Context');

var _Context2 = _interopRequireDefault(_Context);

var _utils = require('./utils');

var _Field = require('../Field');

var _Field2 = _interopRequireDefault(_Field);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * TextField Component for SaltUI
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2018-2019, SaltUI Team.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var TextField = function (_React$Component) {
  _inherits(TextField, _React$Component);

  function TextField() {
    _classCallCheck(this, TextField);

    return _possibleConstructorReturn(this, (TextField.__proto__ || Object.getPrototypeOf(TextField)).apply(this, arguments));
  }

  _createClass(TextField, [{
    key: 'getAddons',
    value: function getAddons() {
      var addons = {};
      _react2.default.Children.forEach(this.props.children, function (child) {
        if (typeof child.type === 'function') {
          if (child.type.displayName === 'LeftAddon' && !addons.left) {
            addons.left = child;
          } else if (child.type.displayName === 'RightAddon' && !addons.right) {
            addons.right = child;
          } else if (child.type.displayName === 'Count' && !addons.count) {
            addons.count = child;
          }
        }
      });
      return addons;
    }
  }, {
    key: 'getInput',
    value: function getInput() {
      return this.input;
    }
  }, {
    key: 'handleChange',
    value: function handleChange(e) {
      var value = this.props.filter(e.target.value);
      this.props.onChange(value, e);
    }
  }, {
    key: 'handleFocus',
    value: function handleFocus(e) {
      var t = this;
      t.props.onFocus(t.props.value, e);
    }
  }, {
    key: 'handleBlur',
    value: function handleBlur(e) {
      var t = this;
      t.props.onBlur(t.props.value, e);
    }
  }, {
    key: 'renderInput',
    value: function renderInput() {
      var _this2 = this;

      var t = this;
      var _t$props = t.props,
          readOnly = _t$props.readOnly,
          renderView = _t$props.renderView;

      return _react2.default.createElement(
        'div',
        { className: (0, _Context.prefixClass)('text-field-content-main') },
        _react2.default.createElement(
          'div',
          {
            className: (0, _classnames4.default)((0, _Context.prefixClass)('omit text-field-placeholder'), _defineProperty({}, (0, _Context.prefixClass)('DN'), t.props.value !== ''))
          },
          readOnly ? '' : t.props.placeholder
        ),
        !readOnly ? _react2.default.createElement('input', {
          ref: function ref(c) {
            _this2.input = c;
          },
          className: (0, _Context.prefixClass)('text-field-input'),
          type: t.props.type,
          value: t.props.value,
          readOnly: t.props.readOnly,
          disabled: t.props.disabled,
          onChange: function onChange(e) {
            t.handleChange(e);
          },
          onFocus: function onFocus(e) {
            t.handleFocus(e);
          },
          onBlur: function onBlur(e) {
            t.handleBlur(e);
          }
        }) : _react2.default.createElement(
          'span',
          null,
          renderView ? renderView(t.props.value) : t.props.value || '　'
        )
      );
    }
  }, {
    key: 'renderClear',
    value: function renderClear(addons) {
      var _this3 = this;

      var _props = this.props,
          value = _props.value,
          allowClear = _props.allowClear,
          readOnly = _props.readOnly,
          disabled = _props.disabled;

      if (value && allowClear && !readOnly && !disabled) {
        return _react2.default.createElement(_CrossRound2.default, {
          onClick: function onClick(e) {
            _this3.props.onChange('', e);
          },
          className: (0, _classnames4.default)((0, _Context.prefixClass)('text-field-clear-icon'), _defineProperty({}, (0, _Context.prefixClass)('text-field-clear-icon__hasRight'), addons.right || addons.count))
        });
      }
      return null;
    }
  }, {
    key: 'render',
    value: function render() {
      var t = this;
      var addons = t.getAddons();
      return _react2.default.createElement(
        _Field2.default,
        _extends({}, t.props, {
          multiLine: t.props.readOnly,
          className: (0, _classnames4.default)((0, _Context.prefixClass)('text-field'), t.props.className, {
            readonly: t.props.readOnly
          })
        }),
        _react2.default.createElement(
          'div',
          { className: (0, _Context.prefixClass)('text-field-content') },
          (0, _utils.renderLeft)(addons),
          t.renderInput(),
          t.renderClear(addons),
          (0, _utils.renderRight)(addons)
        )
      );
    }
  }]);

  return TextField;
}(_react2.default.Component);

TextField.defaultProps = {
  className: '',
  filter: function filter(v) {
    return v;
  },
  label: '',
  onChange: _Context2.default.noop,
  onFocus: _Context2.default.noop,
  onBlur: _Context2.default.noop,
  placeholder: '',
  readOnly: false,
  disabled: false,
  type: 'text',
  value: '',
  allowClear: true,
  children: undefined,
  renderView: undefined
};

TextField.propTypes = {
  className: _propTypes2.default.string,
  filter: _propTypes2.default.func,
  label: _propTypes2.default.string,
  onChange: _propTypes2.default.func,
  onFocus: _propTypes2.default.func,
  onBlur: _propTypes2.default.func,
  placeholder: _propTypes2.default.string,
  readOnly: _propTypes2.default.bool,
  type: _propTypes2.default.string,
  value: _propTypes2.default.string,
  children: _propTypes2.default.any,
  allowClear: _propTypes2.default.bool,
  disabled: _propTypes2.default.bool,
  renderView: _propTypes2.default.func
};

TextField.displayName = 'TextField';

exports.default = TextField;
module.exports = exports['default'];