'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.shouldUpdate = exports.stopBodyScroll = exports.getLocale = exports.stopBodyScrolling = undefined;

var _contains = require('rc-util/lib/Dom/contains');

var _contains2 = _interopRequireDefault(_contains);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Utils for SaltUI
 * @author eternalsky
 *
 * Copyright 2014-2018, XUX Team.
 * All rights reserved.
 */

var preventDefault = function preventDefault(e) {
  e.preventDefault();
};

var stopBodyScrolling = function stopBodyScrolling(bool) {
  if (bool === true) {
    document.body.addEventListener('touchmove', preventDefault, { capture: false, passive: false });
  } else {
    document.body.removeEventListener('touchmove', preventDefault, { capture: false, passive: false });
  }
};

var stopBodyScroll = function stopBodyScroll(element) {
  var pd = function pd(e) {
    var ele = typeof element === 'function' ? element() : element;
    if (!ele || !(0, _contains2.default)(ele, e.target)) {
      e.preventDefault();
    }
  };
  document.body.addEventListener('touchmove', pd, { capture: false, passive: false });
  // TODO how to stop body scroll when element is scrolled to the end?
  // const sp = (e) => {
  //   e.stopPropagation();
  // };
  // if (element) {
  //   element.addEventListener('touchmove', sp, false);
  // }
  return {
    enable: function enable() {
      document.body.removeEventListener('touchmove', pd, { capture: false, passive: false });
      // if (element) {
      //   element.removeEventListener('touchmove', sp, false);
      // }
    }
  };
};

// uniform locale for en-us, en_US
var getLocale = function getLocale(locale) {
  if (typeof locale === 'string') {
    var spliter = locale.match(/[-_]/) ? locale.match(/[-_]/)[0] : '';
    if (!spliter) {
      return locale;
    }
    return locale.toLowerCase().split(spliter).join('-');
  }
  return locale;
};

var shouldUpdate = function shouldUpdate(prevProps, nextProps) {
  var keys = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];

  var update = false;
  for (var i = 0; i < keys.length; i++) {
    var key = keys[i];
    update = !(0, _isEqual2.default)(prevProps[key], nextProps[key]);
    if (update) break;
  }
  return update;
};

exports.stopBodyScrolling = stopBodyScrolling;
exports.getLocale = getLocale;
exports.stopBodyScroll = stopBodyScroll;
exports.shouldUpdate = shouldUpdate;